////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}
  
std::string toString(const std::vector<int> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const int &i:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(std::to_string(i) );
  }
  return result;
}
  
std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\250\006\000\000\251\006\000\000\253\006\000\000\031\007\000\000\032\007\000\000\034\007"
  "\000\000\030\010\000\000\262\t\000\000\322\t\000\000\007\n\000\000\023\n\000\000\037\n\000\000f\n\000\000r\n\000\000~"
  "\n\000\000\267\n\000\000\303\n\000\000\317\n\000\000|\013\000\000>\015\000\000O\015\000\000[\015\000\000\264\016\000"
  "\000\275\016\000\0008\017\000\000A\017\000\000[\017\000\000\303\017\000\000\314\017\000\000\325\017\000\000\361\017"
  "\000\000 \021\000\000\242\021\000\000\271\021\000\000\243\024\000\000\247\024\000\000\024\027\000\000\230\027\000\000"
  "\333\027\000\000\316\030\000\000\t\032\000\000\015\032\000\000\210\034\000\000\212\034\000\000\366\034\000\000\302"
  "\035\000\000\303\035\000\000\305\035\000\000\214\036\000\000\246\036\000\000\257\036\000\000\274\036\000\000\346\036"
  "\000\000\015\037\000\000\016\037\000\000\020\037\000\000*\037\000\000+\037\000\000-\037\000\0009\037\000\000R\037\000"
  "\000V\037\000\000W\037\000\000e\037\000\000v\037\000\000w\037\000\000y\037\000\000|\037\000\000\200\037\000\000\202"
  "\037\000\000\225\037\000\000\234\037\000\000\236\037\000\000\237\037\000\000\252\037\000\000\261\037\000\000\276\037"
  "\000\000\277\037\000\000\301\037\000\000\353\037\000\000\355\037\000\000\020 \000\000\022 \000\000- \000\0006 \000"
  "\000B \000\000C \000\000E \000\000h \000\000t \000\000} \000\000\211 \000\000\212 \000\000\214 \000\000\256 \000\000"
  "\272 \000\000\303 \000\000\317 \000\000\355 \000\000\371 \000\000\002!\000\000\016!\000\000\017!\000\000\021!\000\000"
  "-!\000\0009!\000\000B!\000\000J!\000\000O!\000\000P!\000\000R!\000\000T!\000\000U!\000\000v!\000\000\202!\000\000\213"
  "!\000\000\223!\000\000\224!\000\000\226!\000\000\270!\000\000\304!\000\000\315!\000\000\325!\000\000\327!\000\000\331"
  "!\000\000\032$\000\000-$\000\000g$\000\000q$\000\000\216$\000\000\230$\000\000\265$\000\000\225%\000\000\365%\000\000"
  "\366%\000\000\370%\000\000o&\000\000\250'\000\000\310'\000\000$(\000\000)(\000\000.(\000\0003(\000\0008(\000\000m("
  "\000\000r(\000\000\232(\000\000\367(\000\000!)\000\0008)\000\0009)\000\000;)\000\000<)\000\000=)\000\000@)\000\000A)"
  "\000\000j)\000\000v)\000\000\177)\000\000\213)\000\000\214)\000\000\216)\000\000\217)\000\000\221)\000\000\222)\000"
  "\000\327)\000\000\341)\000\000\342)\000\000\037*\000\000#*\000\000'*\000\0009*\000\000U*\000\000W*\000\000]*\000\000q"
  "*\000\000s*\000\000{*\000\000\217*\000\000\225*\000\000\300*\000\000\314*\000\000\325*\000\000\350*\000\000\374*\000"
  "\000\376*\000\000\006+\000\000\032+\000\000\034+\000\000$+\000\0008+\000\000;+\000\000>+\000\000\?+\000\000G+\000\000"
  "H+\000\000J+\000\000l+\000\000\251+\000\000\317+\000\000\003,\000\000\010,\000\000\026,\000\000N,\000\000R,\000\000`,"
  "\000\000\227,\000\000\234,\000\000\252,\000\000\342,\000\000\347,\000\000\363,\000\000\010-\000\000\017-\000\000y-"
  "\000\000\321-\000\000\344-\000\000\346-\000\000\375-\000\000\377-\000\000\007.\000\000(.\000\0005.\000\000Y.\000\000z"
  ".\000\000\202.\000\000\216.\000\000\217.\000\000\262.\000\000\271.\000\000\335.\000\000\374.\000\000$/\000\000C/\000"
  "\000c/\000\000\200/\000\000\256/\000\000\322/\000\000\352/\000\000\0270\000\00060\000\000P0\000\000\2000\000\000\2410"
  "\000\000\2730\000\000\2740\000\000\3500\000\000\3510\000\000\n1\000\000\0271\000\000\0311\000\000%1\000\00071\000\000"
  "S1\000\000\1341\000\000c1\000\000\1771\000\000\2001\000\000\2071\000\000\2451\000\000\2471\000\000\2501\000\000\2511"
  "\000\000\3161\000\000\3211\000\000\3301\000\000\3701\000\000\3711\000\000\3741\000\000\0032\000\000!2\000\000\"2\000"
  "\000)2\000\000I2\000\000J2\000\000Q2\000\000R2\000\000|2\000\000\2172\000\000\2252\000\000\2652\000\000\3122\000\000"
  "\3642\000\000\0103\000\000\0333\000\000E3\000\000Y3\000\000l3\000\000\2263\000\000\2523\000\000\2753\000\000\3143\000"
  "\000\3503\000\000\3603\000\000\3673\000\000\0234\000\000\0324\000\000=4\000\000F4\000\000M4\000\000s4\000\000\2054"
  "\000\000\2204\000\000\2544\000\000\2574\000\000\2664\000\000\3224\000\000\3324\000\000\3414\000\000\3754\000\000\0025"
  "\000\000\t5\000\000%5\000\000&5\000\000)5\000\00005\000\00015\000\000z5\000\000\2155\000\000\2365\000\000\2375\000"
  "\000\2755\000\000\3065\000\000\3155\000\000\3535\000\000\3635\000\000\3725\000\000\3735\000\000\0316\000\000\0326\000"
  "\000!6\000\000\?6\000\000H6\000\000O6\000\000P6\000\000n6\000\000\2016\000\000\2536\000\000\2776\000\000\3226\000\000"
  "\0007\000\000\0267\000\000+7\000\000Y7\000\000o7\000\000\2047\000\000\2177\000\000\2267\000\000\2427\000\000\2637\000"
  "\000\2737\000\000\3067\000\000\3517\000\000\0318\000\000 8\000\000\"8\000\000W8\000\000m8\000\000s8\000\000\2058\000"
  "\000\2138\000\000\2248\000\000\2338\000\000\2478\000\000\2718\000\000\2728\000\000\2738\000\000\3038\000\000\3178\000"
  "\000\3338\000\000\0109\000\000\t9\000\000\n9\000\000 9\000\000L9\000\000q9\000\000s9\000\000\3549\000\000S:\000\000"
  "\202:\000\000\336:\000\000C;\000\000\334;\000\000<<\000\000\232<\000\000\375<\000\000q=\000\000\240=\000\000\305=\000"
  "\000\350=\000\000\015>\000\000:>\000\000\230>\000\000\266>\000\000\272>\000\000\300>\000\000\302>\000\000\303>\000"
  "\000\311>\000\000\313>\000\000\314>\000\000!\?\000\000\211\?\000\000\247\?\000\000\253\?\000\000\261\?\000\000\263\?"
  "\000\000\264\?\000\000\272\?\000\000\274\?\000\000\275\?\000\000\022@\000\000s@\000\000\221@\000\000\225@\000\000\233"
  "@\000\000\235@\000\000\236@\000\000\244@\000\000\246@\000\000\247@\000\000\370@\000\0004A\000\000/D\000\000^D\000\000"
  "NE\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-s"
  "trict.dtd\">\n\n\n\n<script type=\"text/javascript\" src=\"js/live/createHtml.js\"></script>\n<script>\nfunction addE"
  "rrorIcon(s, numErrors, durationDeviation, duration, numTsFiles) {\n  if (numErrors <= -100) return\n  s.a += '<div cl"
  "ass=\"recording_errors\"><img class=\"icon\" src=\"'\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'Record"
  "ingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numEr"
  "rors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  <"
  " 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '\" width = \"16px\" title=\"'\n  if (numErrors == 0) s."
  "a += ''\n  if (numErrors  > 0) s.a += ' ' + String(numErrors)\n  if (numErrors  < 0) s.a += ''\n  s.a += ''\n  s.a +="
  " ''\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a += ':"
  " '\n  s.a += duration\n  s.a += ' '\n  s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a += ': '\n  s.a += String(numTsFiles"
  ")\n  s.a += '\" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s.a += '<div class=\"recording_sd_hd\"><"
  "img class=\"icon\" src=\"'\n  s.a += hdsd\n  s.a += 'd.png\" width = \"25px\" title=\"'\n  s.a += toolTip\n  s.a += '"
  "\" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href=\"http://www.imd"
  "b.com/find\?s=all&q='\n    if (name.startsWith(\"%\") ) {\n      s.a += name.substr(1)\n    } else {\n      s.a += na"
  "me\n    }\n  } else {\n    s.a += '<a href=\"https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '\" t"
  "arget=\"_blank\"><img class=\"icon\" src=\"imdb.png\" title=\"\"/></a>'\n}\n\n\nfunction addEvent(s, bottomrow_i, obj"
  ") {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'"
  "\n  s.a += `<tr><td class=\"action leftcol ${bottomrow}\">`\n  if (obj[1].length != 0) {\n    s.a += '<a href=\"edit_"
  "timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  } else "
  "{\n    s.a += '<a href=\"edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '\"><img class=\"icon\" src=\""
  "\" title=\"\" />'\n  }\n  s.a += '</a>'\n  s.a += '<a href=\"searchresults.html\?searchplain='\n  s.a += obj[11]\n  s"
  ".a += '\"><img class=\"icon\" src=\"\" title=\"\"/></a>'\n  IMDBS(s, obj[2], obj[11])\n  s.a += '</td>'\n// second co"
  "l, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div class="
  "\"hidden-xs withmargin\"><a href=\"schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '\">'\n    s.a += obj[10]"
  "\n    s.a += '</a></div></td>'\n  }\n// third col: image\n    s.a += `<td class=\"enlarge-image ${bottomrow}\">`\n   "
  " addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '');\n    s.a += '</td>'\n  s.a += `<td clas"
  "s=\"td-hidden-xs ${bottomrow}\"><div class=\"hidden-xs withmargin\">`\n  s.a += obj[14]\n  s.a += '</div></td>'\n// c"
  "ol with times, channel, name, short text\n  s.a += `<td class=\"rightcol ${bottomrow}\"><div class=\"withmargin\">`\n"
  "// first line: link to channel, times, channel\n  s.a += '<div class=\"margin-bottom display-xs\">'\n  if (obj[9] > 0"
  ") {\n    s.a += '<a href=\"schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '\">'\n  }\n  s.a += '<span class="
  "\"normal-font\">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'"
  "\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text\n  ad"
  "dEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '', '')\n  s.a += '</div></td></tr>'\n}\nfunction event"
  "String(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = \"\"\n  addEvent(s, bottomrow, data)\n  return s."
  "a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image"
  ", pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short"
  "_text, description, durationDeviation, folder, duration, numTsFiles) {\n  if (archiveDescr.length != 0) col_span1--;"
  "\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class=\"leftcol '\n  s.a += bottomrow\n  s.a"
  " += '\">'\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class=\"action '\n    s.a += bottomrow\n    s.a +="
  " '\"> <img class=\"icon\" src=\"\" alt=\"on dvd\" title=\" />'\n    s.a += archiveDescr\n    s.a += '/>'\n  } else {"
  "\n    s.a += '<br/><table><tr><td class=\"noborder\">'\n    addErrorIcon(s, errors, durationDeviation, duration, numT"
  "sFiles)\n    s.a += '</td><td class=\"noborder\">'\n    addHdSdIcon(s, hd_sd, channel_name)\n    s.a += '</td></tr></"
  "table>'\n  }\n  s.a += '</td><td class=\"td-hidden-xs '\n  s.a += bottomrow\n  s.a += '\"><div class=\"hidden-xs reco"
  "rding_day\">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class=\"rightcol '\n  s.a += bottomrow\n  s.a += "
  "'\">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '', '')\n  s.a"
  " += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, id, archiveDescr, imdb_id, image, pt, s_ti"
  "tle, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, des"
  "cription, durationDeviation, folder, duration, numTsFiles) {\n  const s = Object.create(null)\n  s.a = \"\"\n  existi"
  "ngRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_d"
  "ate, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, "
  "duration, numTsFiles)\n  return s.a\n}\n\n\n</script>\n\n\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/styl"
  "es.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href="
  "\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" src=\"js/live/header.js\"></script>\n<script type=\"text/ja"
  "vascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n\n\n<!-- start of fixed page header -->\n<div id=\"header\" sty"
  "le=\"width: 100%; background-color: inherit\">\n<div id=\"padding\" style=\"display: none\"></div>\n<div id=\"content"
  "\">\n<!-- header content follows -->\n<div class=\"page_header\">\n<a href=\"\">\n<img src=\"\" alt=\"VDR Live!\" cla"
  "ss=\"logo\"></img></a>\n</div>\n<div style=\"clear: both\"></div>\n\n\n\nstyle=\"visibility: hidden\"\n\n\n<div class"
  "=\"\"><div class=\"__elapsed\" id=\"\"style=\"width: px\"></div></div>\n\n\n\n<a id=\"\"  href=\"vdr_request/\?param="
  "\"  ><img src=\"\" alt=\"\"></img></a> \n\n\n<a href=\"http://www.imdb.com/find\?s=all&q=\"\n<a href=\"http://www.imd"
  "b.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\" ></img></a> \n\n\n<a href=\"stream.html\?channelid_str=\"><"
  "img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist.m3u\?channel_str=\"><img src=\"\" alt=\"\" ></img></a>\n<"
  "a href=\"playlist.m3u\?channel=\"><img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist.m3u\?recid=\"><img src"
  "=\"\" alt=\"\" ></img> </a>\n\n\n\n\t\t\n\t\t<a href=\"edit_timer.html\?epgid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n"
  "\n\t<a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\t<script type=\"text/javascript\" "
  "src=\"js/mootools/mootools.v1.11.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/liveajax.js\"></scr"
  "ipt>\n\t<script type=\"text/javascript\" src=\"js/live/infowin.js\"></script>\n\t<script type=\"text/javascript\" src"
  "=\"js/live/hinttips.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/browserwin.js\"></script>\n\t<sc"
  "ript type=\"text/javascript\" src=\"js/live/pageenhance.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\t"
  "var liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t"
  "\t\tloadingMsg: '',\n\t\t\t\t\terrorMsg: ''\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src=\""
  "\" alt=\"\"> ',\n\t\t\t\t\terrorMsg: '<img src=\"\" alt=\"\"> '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n\t<script type"
  "=\"text/javascript\" src=\"js/live/vdr_status.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar InfoBo"
  "x = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request();\n"
  "\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n\n\n\n<di"
  "v id=\"infobox\">\n\t<div class=\"statuscontent\">\n\t\t<div class=\"st_header\">\n\t\t\t<div id=\"infobox_caption\" "
  "class=\"caption\"></div>\n\t\t\t<div id=\"infobox_timenow\" class=\"now\">--:--</div>\n\t\t</div>\n\t\t<div class=\"s"
  "t_content\">\n\t\t\t<div id=\"infobox_name\" class=\"name\"></div>\n\t\t\t<div id=\"infobox_duration\" class=\"durati"
  "on\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_controls\">\n\t\t\t<div class=\"st_update\">\n\t\t\t\t<a href=\"jav"
  "ascript:InfoBox.toggleUpdate()\" ><img id=\"statusReloadBtn\" src=\"\" alt=\"\" /></a>\n\t\t\t</div>\n\t\t\t<div id="
  "\"infobox_recording_buttons\" style=\"display: none\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div"
  ">\n\t\t\t<div id=\"infobox_channel_buttons\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"st_pbar\">\n\t\t"
  "\t\t\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style=\"display: none;\">\n\t\t<span id=\"__infobox_request_err\"></"
  "span>\n\t\t<span id=\"__infobox_update_err\"></span>\n\t</div>\n</div>\n\n\n\n\t\n\t  \n\t<a href=\"searchresults.htm"
  "l\?searchplain=\"><img src=\"\" alt=\"\" ></img></a>\n\t\n\t\n\t\t\n<img data-src=\"img/transparent.png\" height=\"10"
  "px\" />\n<span id=\"icons-\"></span>\n\n\t\t\t\t\t<script class=\"injectIcons\">\n\t\t\t\t\tinjectHdSdIcon(\"icons-\""
  ", \"\", \"\")\n\t\t\t\t\t</script>\n\t\t<td class=\"action leftcol \"></td>\n\t\t<td class=\"action \"></td>\n\t\t\t"
  "\t<td class=\"action \">\n\t\t\t\t\t\t<a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a>"
  "</td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \">\n\t\t"
  "\t\n\t\t</td>\n\n\n\n\t<div class=\"epg_description\" id=\"\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxhe"
  "ader\">\n\n<div>\n<div class = \"caption menu\">\n  <a id=\"_epg_m\"     class = \"active\"   onclick=\"displayEPG(''"
  ")\" ></a>\n| <a id=\"_scraper_m\" class = \"inactive\" onclick=\"displayScraper('')\"></a>\n| <a id=\"_actors_m\"  cl"
  "ass = \"inactive\" onclick=\"displayActors('')\" ></a>\n| <a id=\"_artwork_m\" class = \"inactive\" onclick=\"display"
  "Artwork('')\" ></a>\n</div>\n<div class=\"caption\"></div>\n</div>\n                        </div>\n\t\t</div>\n\t\t<"
  "div class=\"epg_content\">\n\t\t\t<div class=\"epg_tools\">\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"epg_info\">\n"
  "\t\t\t\t<div class=\"info\">\n\t\t\t\t\t<div class=\"duration\">\n\t\t\t\t\t\t<span title=\"\"></span> / <span title="
  "\"\"></span>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<div class=\"time\">"
  "\n              <span class=\"bold\"></span>\n            \n              <div class=\"channel\"></div>\n\t\t\t\t\t</"
  "div>\n\t\t\t\t\t<div class=\"title\"></div>\n\t\t\t\t\t<div class=\"short\"></div>\n\t\t\t\t\t<div class=\"descriptio"
  "n\" id=_description>\n\t\t\t\t\t<span id = \"_epg_image\" class=\"epg_images\">\n         <a href=\"/epgimages/\" tar"
  "get=\"_blank\">\n\t\t\t\t\t\t<img src=\"/epgimages/\" class=\"epg_image\"/>\n         </a>\n    <a href=\"/tvscraper/"
  "\" target=\"_blank\">\n\t    <img src=\"/tvscraper/\" class=\"epg_image\"/>\n    </a>\n      <a href=\"/tvscraper/\" "
  "target=\"_blank\">\n        <img src=\"/tvscraper/\" class=\"epg_image\"/>\n      </a>\n      <a href=\"/recimages//"
  "\" target=\"_blank\">\n\t\t\t\t<img src=\"/recimages//\" class=\"epg_image\"/>\n      </a>\n\t\t\t\t\t</span> \n\n\n<"
  "div id = '_scraper' hidden>\n  <div class=\"scraper_list\">         </div>\n  <div class=\"scraper_list\"> </div>\n  "
  "  <div class=\"scraper_list\"> SE </div>\n    <div class=\"scraper_list\">   </div>\n      <div class=\"scraper_list"
  "\">  / </div>\n    <div class=\"scraper_list\"> </div>\n      <div class=\"scraper_list\"> </div>\n\n      <a href=\""
  "https://www.imdb.com/title/\" target=\"_blank\">  </a>\n      <div class=\"scraper_list\"></div>\n      <table>\n    "
  "  <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"ca"
  "st_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td"
  ">  </td>\n      </tr>\n      </table>\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list\">  "
  "     </div>\n  <div class=\"scraper_list\">         </div>\n  <div class=\"scraper_list\"><a href =\"\" target=\"_bla"
  "nk\"></a></div>\n  <div class=\"scraper_list\">   </div>\n  <div class=\"scraper_list\">        </div>\n  <div class="
  "\"scraper_list\">     </div>\n  <div class=\"scraper_list\">  / </div>\n\n    <div class=\"scraper_list\">\n      <a "
  "href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n    </div>\n\n    <div class=\"scraper_list\">        "
  " </div>\n    <div class=\"scraper_list\">        </div>\n\n    <div class=\"scraper_list\"> </div>\n    <div class=\""
  "scraper_list\">         </div>\n\n    <div class=\"scraper_list\"></div>\n    <table>\n      <tr>\n        <td class="
  "\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n        <tr>\n          <td class=\"cast_role\">  </td>\n   "
  "       <td>  </td>\n        </tr>\n        <tr>\n          <td class=\"cast_role\">  </td>\n          <td>  </td>\n  "
  "      </tr>\n  </table>\n</div>\n\n<div id = '_actors' hidden>\n<table>\n      <tr>\n    <td>\n      <a href=\"/tvscr"
  "aper/\" target=\"_blank\">\n        <img src=\"/tvscraper/\" alt=\": \" class=\"actor\">\n        </img>\n      </a>"
  "\n    </td>\n      </tr>\n      <tr></tr>\n    </tr>\n    <tr></tr>\n</table>\n</div>\n\n<div id = '_artwork' hidden>"
  "\n\n\n\n</div>\n\n<div id = '_epg'>\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n\n\n  <a h"
  "ref=\"/tvscraper/\" target=\"_blank\">\n    <img src=\"/tvscraper/\" class=\"artwork\">\n    </img>\n  </a>\n\n\n\t<d"
  "iv class=\"epg_description\" id=\"aboutBox\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxheader\"><div><div "
  "class=\"caption\"></div></div></div>\n\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div>\n\t\t\t\t<div class=\""
  "about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_righ"
  "t\">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Sascha "
  "Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Markus Eh"
  "rnsperger (MarkusE @ <a href=\"https://www.vdr-portal.de\">VDR Portal</a>)</div>\n\t\t\t\t<div class=\"about_left\">:"
  "</div>\n\t\t\t\t<div class=\"about_right\">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class=\"about_left\">:</div>"
  "\n\t\t\t\t<div class=\"about_right\">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t"
  "\t<div class=\"about_right\">Christian Wieninger (winni)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<d"
  "iv class=\"about_right\">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class=\"about_head\"><div><div></div>"
  "</div></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div clas"
  "s=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div class=\"about_head\"><div><div></di"
  "v></div></div>\n\t\t\t\t<div class=\"about_left\">EPGsearch:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<i"
  "mg align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/vdr-projects/"
  "vdr-plugin-epgsearch\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">Streamdev serv"
  "er:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t"
  "\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/vdr-projects/vdr-plugin-streamdev\" target=\"_blank\"></a>)<br/>\n\t"
  "\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">tvscraper:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img"
  " align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/MarkusEh/vdr-pl"
  "ugin-tvscraper\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></di"
  "v></div>\n\t\t\t\t<div class=\"about_line\">Movie information provided by <a target=\"_blank\" href=\"https://www.the"
  "moviedb.org/\">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB</div>\n\t\t\t\t<div "
  "class=\"about_line\">Information provided by TheTVDB.com. Please consider <a target=\"_blank\" href=\"https://u105057"
  "76.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRk"
  "IvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAb"
  "H8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8"
  "fnUs-3D\">supporting them</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div cla"
  "ss=\"about_line\">:<br/>\n\t\t\t\t\t<a target=\"_blank\" href=\"https://github.com/MarkusEh/vdr-plugin-live/issues\">"
  "https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div>&nbsp;</div"
  "></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[42]; // \n\n
  reply.out() << _tntChunks[45]; // \n
  reply.out() << _tntChunks[46]; // \n\n
  reply.out() << _tntChunks[53]; // \n
  reply.out() << _tntChunks[54]; // \n\n
  reply.out() << _tntChunks[56]; // \n
  reply.out() << _tntChunks[57]; // \n\n
  reply.out() << _tntChunks[64]; // \n
  reply.out() << _tntChunks[65]; // \n\n
  reply.out() << _tntChunks[76]; // \n
  reply.out() << _tntChunks[77]; // \n\n
  reply.out() << _tntChunks[85]; // \n
  reply.out() << _tntChunks[86]; // \n\n
  reply.out() << _tntChunks[91]; // \n
  reply.out() << _tntChunks[92]; // \n\n
  reply.out() << _tntChunks[101]; // \n
  reply.out() << _tntChunks[102]; // \n\n
  reply.out() << _tntChunks[108]; // \n
  reply.out() << _tntChunks[109]; // \n\n
  reply.out() << _tntChunks[116]; // \n
  reply.out() << _tntChunks[117]; // \n\n
  reply.out() << _tntChunks[122]; // \n\n
  reply.out() << _tntChunks[123]; // \n\n
  reply.out() << _tntChunks[133]; // \n
  reply.out() << _tntChunks[134]; // \n\n
  reply.out() << _tntChunks[149]; // \n
  reply.out() << _tntChunks[150]; // \n\n
  reply.out() << _tntChunks[194]; // \n
  reply.out() << _tntChunks[195]; // \n\n
  reply.out() << _tntChunks[370]; // \n
  reply.out() << _tntChunks[371]; // \n
  reply.out() << _tntChunks[375]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 63 "pageelems.ecpp"

const char *lf;
if (LiveSetup().GetUseAjax()) lf = "<br/>";
else lf = "&#13;";

  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script>\nfunction addErrorIcon(s, numErrors, durationDeviation, duration, numTsFiles) {\n  if (numErrors <= -100) return\n  s.a += '<div class="recording_errors"><img class="icon" src="
#line 72 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[6]; // '\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '" width = "16px" title="'\n  if (numErrors == 0) s.a += '
#line 81 "pageelems.ecpp"
  reply.sout() << (tr("No recording errors"));
  reply.out() << _tntChunks[7]; // '\n  if (numErrors  > 0) s.a += '
#line 82 "pageelems.ecpp"
  reply.sout() << (tr("Number of recording errors:"));
  reply.out() << _tntChunks[8]; //  ' + String(numErrors)\n  if (numErrors  < 0) s.a += '
#line 83 "pageelems.ecpp"
  reply.sout() << (tr("Recording errors unknown"));
  reply.out() << _tntChunks[9]; // '\n  s.a += '
#line 84 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[10]; // '\n  s.a += '
#line 85 "pageelems.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[11]; // '\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += '
#line 89 "pageelems.ecpp"
  reply.sout() << (tr("min"));
  reply.out() << _tntChunks[12]; // '\n  s.a += '
#line 90 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[13]; // '\n  s.a += '
#line 91 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[14]; // '\n  s.a += ': '\n  s.a += duration\n  s.a += ' '\n  s.a += '
#line 95 "pageelems.ecpp"
  reply.sout() << (tr("h"));
  reply.out() << _tntChunks[15]; // '\n  s.a += '
#line 96 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[16]; // '\n  s.a += '
#line 97 "pageelems.ecpp"
  reply.sout() << (tr("Number of ts files"));
  reply.out() << _tntChunks[17]; // '\n  s.a += ': '\n  s.a += String(numTsFiles)\n  s.a += '" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s.a += '<div class="recording_sd_hd"><img class="icon" src="
#line 104 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[18]; // '\n  s.a += hdsd\n  s.a += 'd.png" width = "25px" title="'\n  s.a += toolTip\n  s.a += '" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href="http://www.imdb.com/find\?s=all&q='\n    if (name.startsWith("%") ) {\n      s.a += name.substr(1)\n    } else {\n      s.a += name\n    }\n  } else {\n    s.a += '<a href="https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '" target="_blank"><img class="icon" src="
#line 124 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[19]; // imdb.png" title="
#line 124 "pageelems.ecpp"
  reply.sout() << (tr("Find more at the Internet Movie Database."));
  reply.out() << _tntChunks[20]; // "/></a>'\n}\n\n
  reply.out() << _tntChunks[21]; // \nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class="action leftcol ${bottomrow}">`\n  if (obj[1].length != 0) {\n    s.a += '<a href="edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '"><img class="icon" src="
#line 153 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record_timer.png") );
  reply.out() << _tntChunks[22]; // " title="
#line 153 "pageelems.ecpp"
  reply.sout() << (tr("Edit timer"));
  reply.out() << _tntChunks[23]; // " />'\n  } else {\n    s.a += '<a href="edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '"><img class="icon" src="
#line 157 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[24]; // " title="
#line 157 "pageelems.ecpp"
  reply.sout() << (tr("Record this"));
  reply.out() << _tntChunks[25]; // " />'\n  }\n  s.a += '</a>'\n
#line 160 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() ) { 
  reply.out() << _tntChunks[26]; //   s.a += '<a href="searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '"><img class="icon" src="
#line 163 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[27]; // " title="
#line 163 "pageelems.ecpp"
  reply.sout() << (tr("Search for repeats."));
  reply.out() << _tntChunks[28]; // "/></a>'\n
#line 164 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[29]; //   IMDBS(s, obj[2], obj[11])\n
#line 166 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[30]; //   s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin"><a href="schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n
#line 177 "pageelems.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[31]; //     s.a += `<td class="enlarge-image ${bottomrow}">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 179 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[32]; // ');\n    s.a += '</td>'\n
#line 181 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[33]; //   s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin">`\n  s.a += obj[14]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td class="rightcol ${bottomrow}"><div class="withmargin">`\n// first line: link to channel, times, channel\n  s.a += '<div class="margin-bottom display-xs">'\n  if (obj[9] > 0) {\n    s.a += '<a href="schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '">'\n  }\n  s.a += '<span class="normal-font">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '
#line 204 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[34]; // ', '
#line 204 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[35]; // ')\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = ""\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class="leftcol '\n  s.a += bottomrow\n  s.a += '">
#line 221 "pageelems.ecpp"
  reply.sout() << ( tr("Existing Recording:") );
  reply.out() << _tntChunks[36]; // '\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class="action '\n    s.a += bottomrow\n    s.a += '"> <img class="icon" src="
#line 225 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[37]; // " alt="on dvd" title=" />'\n    s.a += archiveDescr\n    s.a += '/>'\n
#line 228 "pageelems.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[38]; //   } else {\n    s.a += '<br/><table><tr><td class="noborder">'\n    addErrorIcon(s, errors, durationDeviation, duration, numTsFiles)\n    s.a += '</td><td class="noborder">'\n    addHdSdIcon(s, hd_sd, channel_name)\n    s.a += '</td></tr></table>'\n
#line 237 "pageelems.ecpp"

#endif

  reply.out() << _tntChunks[39]; //   }\n  s.a += '</td><td class="td-hidden-xs '\n  s.a += bottomrow\n  s.a += '"><div class="hidden-xs recording_day">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class="rightcol '\n  s.a += bottomrow\n  s.a += '">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '
#line 248 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[40]; // ', '
#line 248 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[41]; // ')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, id, archiveDescr, imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles) {\n  const s = Object.create(null)\n  s.a = ""\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles)\n  return s.a\n}\n\n\n</script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[43]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 265 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[44]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[47]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 279 "pageelems.ecpp"

	if (LiveSetup().GetShowLogo()
		|| (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox())) {

  reply.out() << _tntChunks[48]; // <div class="page_header">\n
#line 284 "pageelems.ecpp"

		if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[49]; // <a href="
#line 287 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[50]; // ">\n<img src="
#line 288 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[51]; // " alt="VDR Live!" class="logo"></img></a>\n
#line 289 "pageelems.ecpp"

		}

#line 292 "pageelems.ecpp"
if (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 292 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 292 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 292 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[52]; // </div>\n<div style="clear: both"></div>\n
#line 295 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 306 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[55]; // style="visibility: hidden"
#line 306 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 317 "pageelems.ecpp"

	std::string cls("__progress");
	if ((duration >= 0) && ((progress < 0) || (duration == 0)))
		cls +="_invisible";

  reply.out() << _tntChunks[58]; // <div class="
#line 322 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[59]; // "><div class="__elapsed" 
#line 322 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[60]; // id="
#line 322 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[61]; // "
#line 322 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[62]; // style="width: 
#line 322 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[63]; // px"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 336 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[66]; // <a 
#line 336 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[67]; // id="
#line 336 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[68]; // " 
#line 336 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 336 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 336 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 336 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[69]; //  href="vdr_request/
#line 336 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[70]; // \?param=
#line 336 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[71]; // " 
#line 336 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 336 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 336 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 336 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[72]; //  
#line 336 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[73]; // ><img src="
#line 336 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[74]; // " alt="
#line 336 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[75]; // "></img></a> 
#line 336 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 346 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[78]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 350 "pageelems.ecpp"
  reply.sout() << ( (!title.empty() && title[0] == '%')?StringUrlEncode(title.substr(1)):StringUrlEncode(title) );
  reply.out() << _tntChunks[79]; // "\n
#line 351 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[80]; // <a href="http://www.imdb.com/title/
#line 352 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[81]; // "\n
#line 353 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[82]; //  target="_blank"><img src="
#line 354 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[83]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 354 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 354 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 354 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[84]; // ></img></a> 
#line 354 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 363 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[87]; // <a href="stream.html\?channelid_str=
#line 366 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[88]; // "><img src="
#line 366 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[89]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 366 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 366 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 366 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[90]; // ></img></a>\n
#line 367 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 378 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {
#if TNTVERSION >= 30000

  reply.out() << _tntChunks[93]; // <a href="playlist.m3u\?channel_str=
#line 382 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[94]; // "><img src="
#line 382 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[95]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 382 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 382 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this channel into media player.")));
#line 382 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[96]; // ></img></a>\n
#line 383 "pageelems.ecpp"

#else

  reply.out() << _tntChunks[97]; // <a href="playlist.m3u\?channel=
#line 386 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[98]; // "><img src="
#line 386 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[99]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 386 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 386 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 386 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[100]; // ></img></a>\n
#line 387 "pageelems.ecpp"

#endif
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 400 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{

  reply.out() << _tntChunks[103]; // <a href="playlist.m3u\?recid=
#line 403 "pageelems.ecpp"
  reply.sout() << ( recid );
  reply.out() << _tntChunks[104]; // "><img src="
#line 403 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[105]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 403 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 403 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 403 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[106]; // ></img> 
#line 403 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[107]; // </a>\n
#line 404 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 416 "pageelems.ecpp"

	tChannelID channelid;
	tEventID eventid;
	EpgEvents::DecodeDomId(epgid, channelid, eventid);
	const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
	if (timer) {

  reply.out() << _tntChunks[110]; // \t\t
  // <& pageelems.edit_timer ...
  { 
#line 423 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 423 "pageelems.ecpp"
    _tnt_cq8.add( "imgName", ("record_timer.png"));
#line 423 "pageelems.ecpp"
    _tnt_cq8.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 423 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[111]; // \n
#line 424 "pageelems.ecpp"

	}
	else {

  reply.out() << _tntChunks[112]; // \t\t<a href="edit_timer.html\?epgid=
#line 428 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[113]; // "><img src="
#line 428 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[114]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 428 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 428 "pageelems.ecpp"
    _tnt_cq9.add( "text", (tr("Record this")));
#line 428 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[115]; //  /></a>\n
#line 429 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[118]; // \t<a href="edit_timer.html\?timerid=
#line 441 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[119]; // "><img src="
#line 441 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[120]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 441 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 441 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Edit timer")));
#line 441 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[121]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 448 "pageelems.ecpp"

	if (LiveSetup().GetUseAjax()) {

  reply.out() << _tntChunks[124]; // \t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n\t<script type="text/javascript" src="js/live/liveajax.js"></script>\n\t<script type="text/javascript" src="js/live/infowin.js"></script>\n\t<script type="text/javascript" src="js/live/hinttips.js"></script>\n\t<script type="text/javascript" src="js/live/browserwin.js"></script>\n\t<script type="text/javascript" src="js/live/pageenhance.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '
#line 461 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[125]; // ',\n\t\t\t\t\terrorMsg: '
#line 462 "pageelems.ecpp"
  reply.sout() << ( tr("an error occured!") );
  reply.out() << _tntChunks[126]; // '\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src="
#line 465 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[127]; // " alt=""> 
#line 465 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[128]; // ',\n\t\t\t\t\terrorMsg: '<img src="
#line 466 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[129]; // " alt=""> 
#line 466 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[130]; // '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n
#line 470 "pageelems.ecpp"

		if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[131]; // \t<script type="text/javascript" src="js/live/vdr_status.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request(
#line 477 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[132]; // );\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n
#line 483 "pageelems.ecpp"

		}

#line 486 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[135]; // <div id="infobox">\n\t<div class="statuscontent">\n\t\t<div class="st_header">\n\t\t\t<div id="infobox_caption" class="caption">
#line 497 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[136]; // </div>\n\t\t\t<div id="infobox_timenow" class="now">--:--</div>\n\t\t</div>\n\t\t<div class="st_content">\n\t\t\t<div id="infobox_name" class="name"></div>\n\t\t\t<div id="infobox_duration" class="duration">--:--</div>\n\t\t</div>\n\t\t<div class="st_controls">\n\t\t\t<div class="st_update">\n\t\t\t\t<a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 506 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 506 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Toggle updates on/off.")));
#line 506 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[137]; // ><img id="statusReloadBtn" src="
#line 506 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[138]; // " alt="" /></a>\n\t\t\t</div>\n\t\t\t<div id="infobox_recording_buttons" style="display: none">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 509 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 509 "pageelems.ecpp"
    _tnt_cq12.add( "action", ("stop_recording"));
#line 509 "pageelems.ecpp"
    _tnt_cq12.add( "id", ("infobox_stop"));
#line 509 "pageelems.ecpp"
    _tnt_cq12.add( "image", ("stop.png"));
#line 509 "pageelems.ecpp"
    _tnt_cq12.add( "tip", (tr("stop playback")));
#line 509 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[139]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 510 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 510 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("play_recording"));
#line 510 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_play"));
#line 510 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("play.png"));
#line 510 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("resume playback")));
#line 510 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[140]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 511 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 511 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("pause_recording"));
#line 511 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_pause"));
#line 511 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("pause.png"));
#line 511 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("pause playback")));
#line 511 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 512 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 512 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("rwd_recording"));
#line 512 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_rwd"));
#line 512 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("rwd.png"));
#line 512 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("fast rewind")));
#line 512 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 513 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 513 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("ffw_recording"));
#line 513 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_ffw"));
#line 513 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("ffw.png"));
#line 513 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast forward")));
#line 513 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[143]; // \n\t\t\t</div>\n\t\t\t<div id="infobox_channel_buttons">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 516 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 516 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("switch_channel"));
#line 516 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_prevchan"));
#line 516 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("one_downarrow.png"));
#line 516 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("previous channel")));
#line 516 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 517 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 517 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 517 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_nextchan"));
#line 517 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_uparrow.png"));
#line 517 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("next channel")));
#line 517 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[145]; // \n\t\t\t</div>\n\t\t\t<div class="st_pbar">\n\t\t\t\t
  // <& progressbar ...
  { 
#line 520 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 520 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_elapsed"));
#line 520 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[146]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="display: none;">\n\t\t<span id="__infobox_request_err">
#line 525 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[147]; // </span>\n\t\t<span id="__infobox_update_err">
#line 526 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[148]; // </span>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 543 "pageelems.ecpp"

	int duration = EpgEvents::Duration(startTime, endTime);
	int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
	tChannelID channelId = tChannelID();

	EpgEvents::DecodeDomId(epgid, channelId, eventId);
	if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[151]; // \t
  // <& pageelems.event_timer ...
  { 
#line 552 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 552 "pageelems.ecpp"
    _tnt_cq20.add( "epgid", (epgid));
#line 552 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[152]; // \n
#line 553 "pageelems.ecpp"

  if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[153]; // \t  
  // <& pageelems.ajax_action_href ...
  { 
#line 556 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 556 "pageelems.ecpp"
    _tnt_cq21.add( "action", "switch_channel");
#line 556 "pageelems.ecpp"
    _tnt_cq21.add( "alt", "");
#line 556 "pageelems.ecpp"
    _tnt_cq21.add( "image", "zap.png");
#line 556 "pageelems.ecpp"
    _tnt_cq21.add( "param", (channelId));
#line 556 "pageelems.ecpp"
    _tnt_cq21.add( "tip", (tr("Switch to this channel.")));
#line 556 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[154]; // \n
#line 557 "pageelems.ecpp"

	} if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[155]; // \t<a href="searchresults.html\?searchplain=
#line 560 "pageelems.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[156]; // "><img src="
#line 560 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[157]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 560 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 560 "pageelems.ecpp"
    _tnt_cq22.add( "text", (tr("Search for repeats.")));
#line 560 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[158]; // ></img></a>\n
#line 561 "pageelems.ecpp"

		}
		if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[159]; // \t
  // <& pageelems.hls_channel ...
  { 
#line 565 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 565 "pageelems.ecpp"
    _tnt_cq23.add( "channelId", (channelId));
#line 565 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[160]; // \n\t
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 566 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 566 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 566 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[161]; // \n
#line 567 "pageelems.ecpp"

		}
	if (eventId != 0) {
    /* Need to lock here channels also, because CreateEpgInfo will lock
     * it also and this will result in a wrong lock order */
    LOCK_CHANNELS_READ;
    LOCK_SCHEDULES_READ;
    EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(epgid, Schedules);
    const cEvent* event = epgEvent->Event();
    const cChannel* channel = event?Channels->GetByChannelID(event->ChannelID()):nullptr;
    cGetScraperVideo getScraperVideo(event, NULL);
    bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
    if (scraperDataAvailable) {
      int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
      char sdhd = video_SD_HD == 0 ? 's': video_SD_HD == 1 ? 'h': video_SD_HD == 2 ? 'u' : 0;


  reply.out() << _tntChunks[162]; // \t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 584 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 584 "pageelems.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 584 "pageelems.ecpp"
    _tnt_cq25.add( "title", (title));
#line 584 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[163]; // \n
#line 585 "pageelems.ecpp"
 if (detail > 1) {

  reply.out() << _tntChunks[164]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 587 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[165]; // "></span>\n
  reply.out() << _tntChunks[166]; // \n
#line 591 "pageelems.ecpp"
 if (sdhd) { 
  reply.out() << _tntChunks[167]; // \t\t\t\t\t<script class="injectIcons">\n\t\t\t\t\tinjectHdSdIcon("icons-
#line 593 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[168]; // ", "
#line 593 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[169]; // ", "
#line 593 "pageelems.ecpp"
  reply.sout() << ((channel&&channel->Name())?channel->Name():"");
  reply.out() << _tntChunks[170]; // ")\n\t\t\t\t\t</script>\n
#line 595 "pageelems.ecpp"

				}
		  }
		}
		}
	}
	else { // table output

  reply.out() << _tntChunks[171]; // \t\t<td class="action leftcol 
#line 603 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[172]; // ">
  // <& pageelems.event_timer ...
  { 
#line 603 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 603 "pageelems.ecpp"
    _tnt_cq26.add( "epgid", (epgid));
#line 603 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[173]; // </td>\n
#line 604 "pageelems.ecpp"

    if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[174]; // \t\t<td class="action 
#line 607 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[175]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 607 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 607 "pageelems.ecpp"
    _tnt_cq27.add( "action", "switch_channel");
#line 607 "pageelems.ecpp"
    _tnt_cq27.add( "alt", "");
#line 607 "pageelems.ecpp"
    _tnt_cq27.add( "image", "zap.png");
#line 607 "pageelems.ecpp"
    _tnt_cq27.add( "param", (channelId));
#line 607 "pageelems.ecpp"
    _tnt_cq27.add( "tip", (tr("Switch to this channel.")));
#line 607 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[176]; // </td>\n\t\t
#line 608 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) { 
  reply.out() << _tntChunks[177]; // \t\t<td class="action 
#line 609 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[178]; // ">\n\t\t\t
#line 610 "pageelems.ecpp"
 if (eventId) { 
  reply.out() << _tntChunks[179]; // \t\t\t<a href="searchresults.html\?searchplain=
#line 611 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[180]; // "><img src="
#line 611 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[181]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 611 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 611 "pageelems.ecpp"
    _tnt_cq28.add( "text", (tr("Search for repeats.")));
#line 611 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[182]; // ></img></a></td>\n\t\t
#line 612 "pageelems.ecpp"
 } } 
  reply.out() << _tntChunks[183]; // \t\t<td class="action 
#line 613 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[184]; // ">
#line 613 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.hls_channel ...
  { 
#line 613 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 613 "pageelems.ecpp"
    _tnt_cq29.add( "channelId", (channelId));
#line 613 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq29);
    // &>
  }
#line 613 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[185]; // </td>\n\t\t
#line 614 "pageelems.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[186]; // \t\t<td class="action 
#line 615 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[187]; // ">
#line 615 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 615 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 615 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 615 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq30);
    // &>
  }
#line 615 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[188]; // </td>\n\t\t
#line 616 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[189]; // \t\t<td class="action 
#line 617 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[190]; // ">\n
#line 618 "pageelems.ecpp"

			if (eventId != 0) {

  reply.out() << _tntChunks[191]; // \t\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 621 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 621 "pageelems.ecpp"
    _tnt_cq31.add( "s_IMDB_ID", (s_IMDB_ID));
#line 621 "pageelems.ecpp"
    _tnt_cq31.add( "title", (title));
#line 621 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[192]; // \n
#line 622 "pageelems.ecpp"

			}

  reply.out() << _tntChunks[193]; // \t\t</td>\n
#line 626 "pageelems.ecpp"

	} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[196]; // \t<div class="epg_description" id="
#line 651 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[197]; // ">\n\t\t<div class="station">\n\t\t\t<div class="boxheader">\n\n<div>\n
#line 656 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent;
if (iepgEvent) epgEvent = *static_cast<EpgInfoPtr*>((void *)iepgEvent);


sScraperMovieOrTv scraperMovieOrTv;
cGetScraperVideo getScraperVideo(static_cast<cEvent *>((void *)ievent), static_cast<cRecording *>((void *)irecording));
scraperMovieOrTv.found = getScraperVideo.call(LiveSetup().GetPluginScraper());
if (scraperMovieOrTv.found) {
  tvType type = getScraperVideo.m_scraperVideo->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = getScraperVideo.m_scraperVideo->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}
std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = getScraperVideo.m_scraperVideo->getCharacters(false);
  scraperMovieOrTv.posters = getScraperVideo.m_scraperVideo->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = getScraperVideo.m_scraperVideo->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = getScraperVideo.m_scraperVideo->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = getScraperVideo.m_scraperVideo->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = getScraperVideo.m_scraperVideo->getEpisodeNumber();
    scraperMovieOrTv.episode.season = getScraperVideo.m_scraperVideo->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[198]; // <div class = "caption menu">\n  <a id="
#line 744 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[199]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 744 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[200]; // ')" >
#line 744 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[201]; // </a>\n| <a id="
#line 745 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[202]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 745 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[203]; // ')">
#line 745 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[204]; // </a>\n| <a id="
#line 746 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[205]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 746 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[206]; // ')" >
#line 746 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[207]; // </a>\n| <a id="
#line 747 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[208]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 747 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[209]; // ')" >
#line 747 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[210]; // </a>\n</div>\n
#line 749 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[211]; // <div class="caption">
#line 752 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[212]; // </div>\n
#line 753 "pageelems.ecpp"

}

  reply.out() << _tntChunks[213]; // </div>\n                        </div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div class="epg_tools">\n\t\t\t\t
  // <& (tools_comp) ...
  { 
#line 761 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 761 "pageelems.ecpp"
    _tnt_cq32.add( "archived", (archived));
#line 761 "pageelems.ecpp"
    _tnt_cq32.add( "detail", (2));
#line 761 "pageelems.ecpp"
    _tnt_cq32.add( "id", (boxId));
#line 761 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 761 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 761 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[214]; // \n\t\t\t</div>\n\t\t\t<div class="epg_info">\n\t\t\t\t<div class="info">\n\t\t\t\t\t<div class="duration">\n
#line 766 "pageelems.ecpp"

if (epgEvent && epgEvent->EventDuration() >= 0) {  // recording

  reply.out() << _tntChunks[215]; // \t\t\t\t\t\t<span title="
#line 769 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[216]; // ">
#line 769 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[217]; // </span> / <span title="
#line 769 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[218]; // ">
#line 769 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[219]; // </span>\n
#line 770 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[220]; // \t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 774 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 774 "pageelems.ecpp"
    _tnt_cq33.add( "progress", (elapsed));
#line 774 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[221]; // </div></div>\n
#line 775 "pageelems.ecpp"

}

  reply.out() << _tntChunks[222]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="time">\n
#line 780 "pageelems.ecpp"
           if (!archived.empty()) {

  reply.out() << _tntChunks[223]; //               <span class="bold">
#line 781 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[224]; // </span>\n
#line 782 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[225]; //             
#line 783 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[226]; // \n
#line 784 "pageelems.ecpp"
           if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[227]; //               <div class="channel">
#line 785 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[228]; // </div>\n
#line 786 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[229]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="title">
#line 788 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[230]; // </div>\n\t\t\t\t\t<div class="short">
#line 789 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[231]; // </div>\n\t\t\t\t\t<div class="description" id=
#line 790 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[232]; // _description>\n\t\t\t\t\t<span id = "
#line 791 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[233]; // _epg_image" class="epg_images">\n
#line 792 "pageelems.ecpp"

	std::list<std::string> images = EpgEvents::EpgImages(boxId);
	for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[234]; //          <a href="/epgimages/
#line 796 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[235]; // " target="_blank">\n\t\t\t\t\t\t<img src="/epgimages/
#line 797 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[236]; // " class="epg_image"/>\n         </a>\n
#line 799 "pageelems.ecpp"

	}
	if(!epgImage.empty() ) {

  reply.out() << _tntChunks[237]; //     <a href="/tvscraper/
#line 803 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[238]; // " target="_blank">\n\t    <img src="/tvscraper/
#line 804 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[239]; // " class="epg_image"/>\n    </a>\n
#line 806 "pageelems.ecpp"
   if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) {

  reply.out() << _tntChunks[240]; //       <a href="/tvscraper/
#line 807 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[241]; // " target="_blank">\n        <img src="/tvscraper/
#line 808 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[242]; // " class="epg_image"/>\n      </a>\n
#line 810 "pageelems.ecpp"

    }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
	} else {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[243]; //       <a href="/recimages/
#line 819 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[244]; // /
#line 819 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[245]; // " target="_blank">\n\t\t\t\t<img src="/recimages/
#line 820 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[246]; // /
#line 820 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[247]; // " class="epg_image"/>\n      </a>\n
#line 822 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[248]; // \t\t\t\t\t</span> 
  reply.out() << _tntChunks[249]; // \n\n
  reply.out() << _tntChunks[250]; // \n<div id = '
#line 829 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[251]; // _scraper' hidden>\n
#line 830 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[252]; //   <div class="scraper_list">
#line 833 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[253]; //          
#line 833 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[254]; // </div>\n
#line 834 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[255]; //   <div class="scraper_list">
#line 837 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[256]; //  
#line 837 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[257]; // </div>\n
#line 838 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[258]; //     <div class="scraper_list">
#line 842 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[259]; //  S
#line 842 "pageelems.ecpp"
  reply.sout() << ( std::to_string(scraperMovieOrTv.episode.season ) );
  reply.out() << _tntChunks[260]; // E
#line 842 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.number ) );
#line 842 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?"A" + std::to_string(scraperMovieOrTv.episode.absoluteNumber):"");
  reply.out() << _tntChunks[261]; //  
#line 842 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.name ) );
  reply.out() << _tntChunks[262]; // </div>\n    <div class="scraper_list">
#line 843 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[263]; //    
#line 843 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[264]; // </div>\n
#line 844 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[265]; //       <div class="scraper_list">
#line 847 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[266]; //  
#line 847 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average ) );
  reply.out() << _tntChunks[267]; //  / 
#line 847 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[268]; // </div>\n
#line 848 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[269]; //     <div class="scraper_list">
#line 851 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[270]; //  
#line 851 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[271]; // </div>\n
#line 852 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[272]; //       <div class="scraper_list">
#line 853 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[273]; //  
#line 853 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.runtime ) );
  reply.out() << _tntChunks[274]; // </div>\n
#line 854 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[275]; // \n
#line 858 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[276]; //       <a href="https://www.imdb.com/title/
#line 859 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[277]; // " target="_blank"> 
#line 859 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[278]; //  </a>\n
#line 860 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[279]; //       <div class="scraper_list">
#line 869 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[280]; // </div>\n      <table>\n
#line 871 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 872 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[281]; //       <tr>\n        <td class="cast_role"> 
#line 874 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[282]; //  </td>\n        <td> 
#line 875 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[283]; //  </td>\n      </tr>\n
#line 877 "pageelems.ecpp"
   }

#line 878 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 879 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[284]; //       <tr>\n        <td class="cast_role"> 
#line 881 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[285]; //  </td>\n        <td> 
#line 882 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[286]; //  </td>\n      </tr>\n
#line 884 "pageelems.ecpp"
   }

#line 885 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 886 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[287]; //       <tr>\n        <td class="cast_role"> 
#line 888 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[288]; //  </td>\n        <td> 
#line 889 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[289]; //  </td>\n      </tr>\n
#line 891 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[290]; //       </table>\n
#line 893 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[291]; //   <div class="scraper_list">
#line 898 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[292]; //         
#line 898 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[293]; // </div>\n
#line 899 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[294]; //   <div class="scraper_list">
#line 902 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[295]; //        
#line 902 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[296]; // </div>\n  <div class="scraper_list">
#line 903 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[297]; //          
#line 903 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[298]; // </div>\n
#line 904 "pageelems.ecpp"

  if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[299]; //   <div class="scraper_list"><a href ="
#line 907 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[300]; // " target="_blank">
#line 907 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[301]; // </a></div>\n
#line 908 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[302]; //   <div class="scraper_list">
#line 911 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[303]; //    
#line 911 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[304]; // </div>\n
#line 912 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[305]; //   <div class="scraper_list">
#line 913 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[306]; //         
#line 913 "pageelems.ecpp"
  reply.sout() << ( std::to_string(scraperMovieOrTv.runtime) );
  reply.out() << _tntChunks[307]; // </div>\n
#line 914 "pageelems.ecpp"
 }

#line 915 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[308]; //   <div class="scraper_list">
#line 918 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[309]; //      
#line 918 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[310]; // </div>\n
#line 919 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[311]; //   <div class="scraper_list">
#line 923 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[312]; //  
#line 923 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[313]; //  / 
#line 923 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount ) );
  reply.out() << _tntChunks[314]; // </div>\n
#line 924 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[315]; // \n
#line 930 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[316]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 932 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[317]; // " target="_blank"> 
#line 932 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[318]; //  </a>\n    </div>\n
#line 934 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[319]; // \n
#line 939 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[320]; //     <div class="scraper_list">
#line 943 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[321]; //          
#line 943 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[322]; // </div>\n
#line 944 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[323]; //     <div class="scraper_list">
#line 948 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[324]; //         
#line 948 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[325]; // </div>\n
#line 949 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[326]; // \n
#line 955 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[327]; //     <div class="scraper_list">
#line 958 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[328]; //  
#line 958 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[329]; // </div>\n
#line 959 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[330]; //     <div class="scraper_list">
#line 963 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[331]; //          
#line 963 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[332]; // </div>\n
  reply.out() << _tntChunks[333]; // \n
#line 967 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[334]; //     <div class="scraper_list">
#line 979 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[335]; // </div>\n    <table>\n
#line 981 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 982 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[336]; //       <tr>\n        <td class="cast_role"> 
#line 984 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[337]; //  </td>\n        <td> 
#line 985 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[338]; //  </td>\n      </tr>\n
#line 987 "pageelems.ecpp"
   }

#line 988 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 989 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 990 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[339]; //         <tr>\n          <td class="cast_role"> 
#line 992 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[340]; //  </td>\n          <td> 
#line 993 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[341]; //  </td>\n        </tr>\n
#line 995 "pageelems.ecpp"
     }

#line 996 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 997 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[342]; //         <tr>\n          <td class="cast_role"> 
#line 999 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[343]; //  </td>\n          <td> 
#line 1000 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[344]; //  </td>\n        </tr>\n
#line 1002 "pageelems.ecpp"
     }

#line 1003 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[345]; //   </table>\n
#line 1005 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[346]; // </div>\n
  reply.out() << _tntChunks[347]; // \n<div id = '
#line 1011 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[348]; // _actors' hidden>\n
#line 1012 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[349]; // <table>\n
#line 1016 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string actor_names = "";

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[350]; //       <tr>\n
#line 1026 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[351]; //     <td>\n      <a href="/tvscraper/
#line 1028 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[352]; // " target="_blank">\n        <img src="/tvscraper/
#line 1029 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[353]; // " alt="
#line 1029 "pageelems.ecpp"
  reply.sout() << (character->getPersonName());
  reply.out() << _tntChunks[354]; // : 
#line 1029 "pageelems.ecpp"
  reply.sout() << (character->getCharacterName());
  reply.out() << _tntChunks[355]; // " class="actor">\n        </img>\n      </a>\n    </td>\n
#line 1033 "pageelems.ecpp"

    actor_names.append("<td>"); 
    actor_names.append(character->getPersonName()); 
    actor_names.append(":<br>"); 
    actor_names.append(character->getCharacterName()); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[356]; //       </tr>\n      <tr>
#line 1042 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[357]; // </tr>\n
#line 1043 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for character in scraperCharacters
  if (num != 1) {

  reply.out() << _tntChunks[358]; //     </tr>\n    <tr>
#line 1052 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[359]; // </tr>\n
#line 1053 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[360]; // </table>\n
#line 1057 "pageelems.ecpp"

}

  reply.out() << _tntChunks[361]; // </div>\n
  reply.out() << _tntChunks[362]; // \n<div id = '
#line 1062 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[363]; // _artwork' hidden>\n
#line 1063 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 1068 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 1068 "pageelems.ecpp"
    _tnt_cq34.add( "media_p", (media_p));
#line 1068 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[364]; // \n
  // <& media ...
  { 
#line 1069 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 1069 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_f));
#line 1069 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[365]; // \n
  // <& media ...
  { 
#line 1070 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 1070 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_b));
#line 1070 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[366]; // \n</div>\n
  reply.out() << _tntChunks[367]; // \n<div id = '
#line 1073 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[368]; // _epg'>\n\t\t\t\t\t
#line 1074 "pageelems.ecpp"
 reply.out() << StringEscapeAndBreak(long_descr); 
  reply.out() << _tntChunks[369]; // \t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 1087 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[372]; //   <a href="/tvscraper/
#line 1091 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[373]; // " target="_blank">\n    <img src="/tvscraper/
#line 1092 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[374]; // " class="artwork">\n    </img>\n  </a>\n
#line 1095 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[376]; // \t<div class="epg_description" id="aboutBox">\n\t\t<div class="station">\n\t\t\t<div class="boxheader"><div><div class="caption">
#line 1104 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[377]; // </div></div></div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1108 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[378]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1109 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[379]; // :</div>\n\t\t\t\t<div class="about_right">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class="about_left">
#line 1111 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[380]; // :</div>\n\t\t\t\t<div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class="about_left">
#line 1113 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[381]; // :</div>\n\t\t\t\t<div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n\t\t\t\t<div class="about_left">
#line 1115 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[382]; // :</div>\n\t\t\t\t<div class="about_right">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class="about_left">
#line 1117 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[383]; // :</div>\n\t\t\t\t<div class="about_right">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class="about_left">
#line 1119 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[384]; // :</div>\n\t\t\t\t<div class="about_right">Christian Wieninger (winni)</div>\n\t\t\t\t<div class="about_left">
#line 1121 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[385]; // :</div>\n\t\t\t\t<div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1123 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[386]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1124 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[387]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1125 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 1125 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[388]; // </div>\n\t\t\t\t<div class="about_left">
#line 1126 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[389]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1127 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[390]; // </div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1128 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[391]; // </div></div></div>\n\t\t\t\t<div class="about_left">EPGsearch:</div>\n\t\t\t\t<div class="about_right">\n
#line 1131 "pageelems.ecpp"
					Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[392]; // \t\t\t\t\t<img align="center" src="
#line 1132 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[393]; // "/>\n
#line 1133 "pageelems.ecpp"
					if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[394]; // \t\t\t\t\t\t
#line 1134 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[395]; // : 
#line 1134 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[396]; // \n
#line 1135 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[397]; // \t\t\t\t\t\t
#line 1136 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[398]; // : 
#line 1136 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[399]; // \n
#line 1137 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[400]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1138 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[401]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">Streamdev server:</div>\n\t\t\t\t<div class="about_right">\n
#line 1142 "pageelems.ecpp"

					Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[402]; // \t\t\t\t\t<img align="center" src="
#line 1145 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[403]; // "/>\n
#line 1146 "pageelems.ecpp"

					if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[404]; // \t\t\t\t\t\t
#line 1149 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[405]; // : 
#line 1149 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[406]; // \n
#line 1150 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[407]; // \t\t\t\t\t\t
#line 1153 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[408]; // : 
#line 1153 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[409]; // \n
#line 1154 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[410]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1157 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[411]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">tvscraper:</div>\n\t\t\t\t<div class="about_right">\n
#line 1161 "pageelems.ecpp"
					Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[412]; // \t\t\t\t\t<img align="center" src="
#line 1162 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[413]; // "/>\n
#line 1163 "pageelems.ecpp"
					if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[414]; // \t\t\t\t\t\t
#line 1164 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[415]; // : 
#line 1164 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[416]; // \n
#line 1165 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[417]; // \t\t\t\t\t\t
#line 1166 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[418]; // : 
#line 1166 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[419]; // \n
#line 1167 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[420]; // \t\t\t\t\t(<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1168 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[421]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1170 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[422]; // </div></div></div>\n\t\t\t\t<div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB</div>\n\t\t\t\t<div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them</a></div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1173 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[423]; // </div></div></div>\n\t\t\t\t<div class="about_line">
#line 1174 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[424]; // :<br/>\n\t\t\t\t\t<a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="about_head"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
