////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <largeString.h>

#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!
#include <string>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "\230\002\000\000\231\002\000\000\232\002\000\000\233\002\000\000\015\003\000\000\032\003"
  "\000\000\037\003\000\000$\003\000\000\?\003\000\000F\003\000\000I\003\000\000K\003\000\000\n\004\000\000\022\004\000"
  "\000\030\004\000\000U\004\000\000{\004\000\000\204\006\000\000\015\007\000\000\203\007\000\000\362\007\000\000\t\010"
  "\000\000\235\t\000\000\001\014\000\000\005\014\000\000\244\014\000\000\372\014\000\000\375\014\000\000I\015\000\000L"
  "\015\000\000n\015\000\000\273\015\000\000-\016\000\000F\016\000\000s\016\000\000j\020\000\000w\020\000\000\203\020"
  "\000\000\226\020\000\000\372\020\000\000\373\020\000\000\375\020\000\000\376\020\000\000\000\021\000\000\001\021\000"
  "\000=\021\000\000P\021\000\000V\021\000\000W\021\000\000\010\022\000\000T\022\000\000\205\022\000\000\264\022\000\000"
  "\016\023\000\0005\023\000\000N\023\000\000O\023\000\000P\023\000\000R\023\000\000\264\023\000\000\327\023\000\000,"
  "\024\000\000]\024\000\000\253\024\000\000\t\025\000\000/\025\000\000\232\025\000\000\265\025\000\000\361\025\000\000"
  "\031\026\000\000&\026\000\000f\026\000\000\241\026\000\000\302\026\000\000\343\026\000\000\373\026\000\000/\027\000"
  "\0001\027\000\0005\027\000\000O\027\000\000t\027\000\000z\027\000\000|\027\000\000\200\027\000\000\230\027\000\000"
  "\372\027\000\000X\030\000\000\266\030\000\000\n\031\000\000L\031\000\000\252\031\000\000\270\031\000\000\360\031\000"
  "\000\361\031\000\000\362\031\000\000\013\032\000\000>\032\000\000D\032\000\000F\032\000\000H\032\000\000\222\032\000"
  "\000\230\032\000\000\232\032\000\000\234\032\000\000\354\032\000\000\362\032\000\000\364\032\000\000\366\032\000\000"
  "\373\032\000\000B\033\000\000H\033\000\000J\033\000\000K\033\000\000P\033\000\000\204\033\000\000\263\033\000\000\343"
  "\033\000\000\347\033\000\000\363\033\000\000\373\033\000\0006\034\000\000\?\034\000\000d\034\000\000m\034\000\000p"
  "\034\000\000w\034\000\000x\034\000\000y\034\000\000\207\034\000\000\210\034\000\000\211\034\000\000\250\034\000\000"
  "\252\034\000\000\265\034\000\000\304\034\000\000\305\034\000\000\306\034\000\000\351\034\000\000\365\034\000\000\376"
  "\034\000\000\005\035\000\000\006\035\000\000\007\035\000\000\010\035\000\000\t\035\000\000\n\035\000\000\013\035\000"
  "\000\014\035\000\000Q\035\000\000\223\035\000\000\226\035\000\000\230\035\000\000\233\035\000\000\237\035\000\000\243"
  "\035\000\000\246\035\000\000\262\035\000\000\263\035\000\000\264\035\000\000\276\035\000\000\315\035\000\000\321\035"
  "\000\000\322\035\000\000\323\035\000\000\324\035\000\000\325\035\000\000\n\n\n\n<html>\n  <head>\n    <meta name=\"vi"
  "ewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    \n<scrip"
  "t>\nconst recs = [];\n  recs[]=[]\nconst rec_ids = Object.create(null)\nrec_ids[\"T\"] = [1, 2]\n\nfunction Recording"
  "ActionS(s, id, A, Img, Title) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&so"
  "rt=&filter=&flat=\" title=\"'\n  s.a += Title\n  s.a += '\"><img class=\"icon\" src=\"'\n  s.a += Img\n  s.a += '\" /"
  "></a>'\n}\n\n\nfunction RecordingsSt(s, level, displayFolder, data) {\n  s.a += '<li class=\"recording\"><div>'\n  s."
  "a += '<table width=\"100%\" class=\"recordings\">'\n  for (obj_i of data) {\n    obj = recs[obj_i]\n    s.a += '<tr c"
  "lass=\"recording_item\">'\n    if (level > 0) s.a += \n      '<td class=\"space\"> <img src=\"img/transparent.png\" w"
  "idth=\"' + String(16 * level) + 'px\" height=\"16px\" /></td>'\n    s.a += '<td class=\"td-hidden-xs\"><div class=\"h"
  "idden-xs recording_imgs\">'\n    if (obj[1].length != 0) {\n      s.a += '<img class=\"icon\" src=\"on_dvd.png\" alt="
  "\"on_dvd\" title=\"'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n      s.a += '<input type=\"checkbox\" na"
  "me=\"deletions\" value=\"recording_'\n      s.a += obj[0]\n      s.a += '\" />'\n    }\n    s.a += '</div></td>'  // "
  "end of recording_imgs\n    s.a += '<td class=\"space\">'\n      addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6"
  "], obj[7], obj[8], '');\n    s.a += '</td>'\n    s.a += '<td class=\"td-hidden-xs\"><div class=\"hidden-xs recording_"
  "day margin-bottom\">'\n    s.a += obj[9]\n    s.a += '</div><div class=\"hidden-xs recording_channel\">'\n    s.a += "
  "obj[12]\n    s.a += '</div></td><td class=\"td-hidden-xs\" style=\"text-align:right\"><div class=\"hidden-xs recordin"
  "g_duration margin-bottom\">'\n    s.a += obj[19]\n    if (obj[17] > 0) {\n      s.a += '<span title=\"'\n      s.a +="
  " ''\n      s.a += '\"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a += '</span>'\n    }\n    s.a += '</"
  "div><div class=\"hidden-xs recording_size\">'\n    s.a += obj[20]\n    s.a += '</div></td><td>'\n    addErrorIcon(s, "
  "obj[10], obj[17], obj[19], obj[21])\n    addHdSdIcon(s, obj[11], obj[12])\n    s.a += '</td>'  // end column with err"
  "or / sd/hd image\n    s.a += '<td><div class=\"recording_name'\n    s.a += obj[13]\n    s.a += '\">'\n    if (display"
  "Folder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class=\"withmargin\">'\n    addEventRec(s, 'rec"
  "ording_', obj[0], obj[14], folder, obj[15], obj[16], '', '')\n    s.a += '</div></div></td>'  // end if recording_nam"
  "e / short description\n    s.a += '<td><div class=\"recording_actions\">'\n    if (obj[1].length == 0) {\n        Rec"
  "ordingActionS(s, obj[0], \"vdr_request/play_recording\?param=\", \"play.png\", \"\")\n        RecordingActionS(s, obj"
  "[0], \"playlist.m3u\?recid=\", \"playlist.png\", \"\")\n        IMDBS(s, obj[2], obj[14])\n      RecordingActionS(s, "
  "obj[0], \"edit_recording.html\?recid=\", \"edit.png\", \"\")\n      s.a += '<div class=\"hidden-ts\">'\n      Recordi"
  "ngActionS(s, obj[0], \"recordings.html\?todel=\", \"del.png\", \"\")\n      s.a += '</div>'\n    } else {\n      IMDB"
  "S(s, obj[2], obj[14])\n    }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n      s.a += '<div class=\"recordin"
  "g_arch\">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'\n  }\n  s.a += '</table></div>"
  "</li>'\n}\n\nfunction rec_string_d(rec_ids) {\n// use img data-src= ...\n  const st = Object.create(null)\n  st.a = "
  "\"\"\n  RecordingsSt(st, rec_ids[0], rec_ids[1], rec_ids[2])\n  return st.a\n}\n\n</script>\n\n  <script type=\"text/"
  "javascript\" src=\"js/live/treeview.js\"></script>\n  <script>\n  const tv = new Treeview(\"minus.png\", \"plus.png\""
  ", \"folder_open.png\", \"folder_closed.png\");\n  </script>\n</head>\n<body onload=\"adjustHeader()\" onresize=\"adju"
  "stHeader()\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div class=\"boxheader\"><div><div></div></div></div>\n     "
  " \n      <form method=\"post\" name=\"recordings\" action=\"recordings.ecpp\">\n        <div class=\"recordings\">\n "
  "         <ul class=\"recordingslist\" style=\"display: block;\">\n            \n          </ul>\n        </div>\n\t\t"
  "\t\t<input type=\"hidden\" name=\"sort\" value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"filter\" value=\"\">\n\t"
  "\t\t\t<input type=\"hidden\" name=\"flat\" value=\"\">\n        <div class=\"withmargin hidden-xs\">\n          <butt"
  "on class=\"red\" type=\"submit\"></button>\n        </div>\n      </form>\n  </div>\n</body>\n</html>\n\n\n\n\n      "
  "<li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n        <tab"
  "le><tr>\n                      <td class = \"space\">\n              <img src=\"img/transparent.png\" width=\"px\" he"
  "ight=\"16px\" />\n            </td>\n                    <td class=\"space\">\n            <img class=\"recording_exp"
  "ander\" src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class=\"recording_folder\" src=\"f"
  "older_closed.png\" />\n          </td>\n            <td class = space>\n              <div class=\"thumb\">\n        "
  "        <img data-src=\"/tvscraper/\"\n                  class=\"\"\n                />\n              </div>\n      "
  "      </td>\n        <td class=\"recording_folder_name\">\n          \n        </td></tr></table>\n        </div>\n  "
  "      <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          \n        </ul>\n      </li>\n  "
  "        <script>\n      rec_ids[\"fldr_\"] = []\n    </script>\n        <script>\n        document.write(rec_string_d"
  "([, , [  ]]))\n      </script>\n          <script>\n        rec_ids[\"fldr_\"] = [, , [  ]]\n      </script>\n       "
  "   <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n         "
  " <table><tr><td class=\"space\">\n            <img class=\"recording_expander\" src=\"plus.png\" />\n          </td><"
  "td class=\"space\">\n            <img class=\"recording_folder\" src=\"folder_closed.png\" />\n          </td><td cla"
  "ss=\"recording_folder_name\">\n            \n          </td></tr></table>\n        </div>\n        <ul id=\"fldr_\" c"
  "lass=\"recordingslist\" style=\"display: none;\">\n          <script>\n            rec_ids[\"fldr_\"] = [1, 1, [  ]]"
  "\n          </script>\n        </ul>\n      </li>\n      \n\n<span class=\"label bold\"> </span>\n<a href=\"recording"
  "s.html\?sort=name&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=date&filter=&"
  "flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=duplicates&filter=&flat=\"  ></a>\n<spa"
  "n class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=errors&filter=&flat=\" ></a>\n<span class=\"sep\">|</span>"
  "\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRe"
  "cordings(this, '', '')\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\""
  "\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\nclass=\"active\"\n\n<a href=\"recordings.html"
  "\?todel=\" ><img src=\"\" alt=\"\" /></a>\n\n<a href=\"edit_recording.html\?recid=\"><img src=\"\" alt=\"\"  /></a>\n"
  "\n\n\n\n\n\n<img data-src=\"img/transparent.png\" height=\"10px\" />\n<span id=\"icons-\"></span>\n<script class=\"in"
  "jectIcons\">\ninjectErrorHdSdIcon(\"icons-\", , , \"\", \"\", \"\", )\n</script>\n\n\n<img src=\"\" alt=\"on_dvd\"  /"
  ">\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 43 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

// create the "current" values of the global request parameters, based on their old values and the current arguments
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
//  if (currentSort.compare(0, 6, "errors", 6) == 0 && currentFlat != "true") currentSort = "dateasc";
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}
for (auto it = deletions.begin(); it != deletions.end(); ++it) {
  if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
    RemoveRecordingTask task(*it);
    LiveTaskManager().Execute(task);
/*
    if (!task.Result())
    deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
    else
*/
    if (task.Result())
      deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
  }
  else {
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  }
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));
#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif
const char *lf;
if (LiveSetup().GetUseAjax()) lf = "<br/>";
else lf = "&#13;";



  // <& pageelems.doc_type ...
  { 
#line 112 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 112 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 116 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 117 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 117 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 118 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 118 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 119 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 119 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recs = [];\n
#line 122 "recordings.ecpp"

cLargeString recoring_item("recoring_item", 25000);
char buffer_i[20];
RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
for (const RecordingsItemPtr &rPtr: *recordingsTree->allRecordings()) {
  recoring_item.clear();
  rPtr->AppendAsJSArray(recoring_item, currentFlat == "true" || currentSort == "duplicates");
  toCharsI(buffer_i, rPtr->IdI());

  reply.out() << _tntChunks[8]; //   recs[
#line 131 "recordings.ecpp"
  reply.sout() << (buffer_i);
  reply.out() << _tntChunks[9]; // ]=[
#line 131 "recordings.ecpp"
  reply.out() << ( recoring_item.c_str() );
  reply.out() << _tntChunks[10]; // ]\n
#line 132 "recordings.ecpp"

}

  reply.out() << _tntChunks[11]; // const rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 143 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[12]; // &filter=
#line 143 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[13]; // &flat=
#line 143 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[14]; // " title="'\n  s.a += Title\n  s.a += '"><img class="icon" src="
#line 145 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[15]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\n\n
  reply.out() << _tntChunks[16]; // \nfunction RecordingsSt(s, level, displayFolder, data) {\n  s.a += '<li class="recording"><div>'\n  s.a += '<table width="100%" class="recordings">'\n  for (obj_i of data) {\n    obj = recs[obj_i]\n    s.a += '<tr class="recording_item">'\n    if (level > 0) s.a += \n      '<td class="space"> <img src="img/transparent.png" width="' + String(16 * level) + 'px" height="16px" /></td>'\n    s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_imgs">'\n    if (obj[1].length != 0) {\n      s.a += '<img class="icon" src="
#line 186 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[17]; // on_dvd.png" alt="on_dvd" title="'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n      s.a += '<input type="checkbox" name="deletions
#line 190 "recordings.ecpp"
  reply.sout() << (TNT_ARRAY);
  reply.out() << _tntChunks[18]; // " value="recording_'\n      s.a += obj[0]\n      s.a += '" />'\n    }\n    s.a += '</div></td>'  // end of recording_imgs\n
#line 195 "recordings.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[19]; //     s.a += '<td class="space">'\n      addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 197 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[20]; // ');\n    s.a += '</td>'\n
#line 199 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[21]; //     s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_day margin-bottom">'\n    s.a += obj[9]\n    s.a += '</div><div class="hidden-xs recording_channel">'\n    s.a += obj[12]\n    s.a += '</div></td><td class="td-hidden-xs" style="text-align:right"><div class="hidden-xs recording_duration margin-bottom">'\n    s.a += obj[19]\n    if (obj[17] > 0) {\n      s.a += '<span title="'\n      s.a += '
#line 208 "recordings.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[22]; // '\n      s.a += '"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a += '</span>'\n    }\n    s.a += '</div><div class="hidden-xs recording_size">'\n    s.a += obj[20]\n    s.a += '</div></td><td>'\n    addErrorIcon(s, obj[10], obj[17], obj[19], obj[21])\n    addHdSdIcon(s, obj[11], obj[12])\n    s.a += '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class="recording_name'\n    s.a += obj[13]\n    s.a += '">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class="withmargin">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], '
#line 226 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[23]; // ', '
#line 226 "recordings.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[24]; // ')\n    s.a += '</div></div></td>'  // end if recording_name / short description\n    s.a += '<td><div class="recording_actions">'\n    if (obj[1].length == 0) {\n
#line 230 "recordings.ecpp"
     if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[25]; //         RecordingActionS(s, obj[0], "vdr_request/play_recording\?param=", "play.png", "
#line 231 "recordings.ecpp"
  reply.sout() << (tr("play this recording"));
  reply.out() << _tntChunks[26]; // ")\n
#line 232 "recordings.ecpp"
     }

#line 233 "recordings.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[27]; //         RecordingActionS(s, obj[0], "playlist.m3u\?recid=", "playlist.png", "
#line 234 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[28]; // ")\n
#line 235 "recordings.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[29]; //         IMDBS(s, obj[2], obj[14])\n
#line 237 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[30]; //       RecordingActionS(s, obj[0], "edit_recording.html\?recid=", "edit.png", "
#line 238 "recordings.ecpp"
  reply.sout() << (tr("Edit recording"));
  reply.out() << _tntChunks[31]; // ")\n      s.a += '<div class="hidden-ts">'\n      RecordingActionS(s, obj[0], "recordings.html\?todel=", "del.png", "
#line 240 "recordings.ecpp"
  reply.sout() << (tr("Delete this recording from hard disc!"));
  reply.out() << _tntChunks[32]; // ")\n      s.a += '</div>'\n
#line 242 "recordings.ecpp"
 if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[33]; //     } else {\n      IMDBS(s, obj[2], obj[14])\n
#line 245 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[34]; //     }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n      s.a += '<div class="recording_arch">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'\n  }\n  s.a += '</table></div></li>'\n}\n\nfunction rec_string_d(rec_ids) {\n// use img data-src= ...\n  const st = Object.create(null)\n  st.a = ""\n  RecordingsSt(st, rec_ids[0], rec_ids[1], rec_ids[2])\n  return st.a\n}\n\n</script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[35]; // minus.png", "
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[36]; // plus.png", "
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[37]; // folder_open.png", "
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[38]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()">\n  
  // <& pageelems.logo ...
  { 
#line 274 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 274 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[39]; // \n
#line 275 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[40]; //   
  // <& menu ...
  { 
#line 282 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 282 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 282 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 282 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 282 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[41]; // \n
#line 283 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[42]; //   
  // <& menu ...
  { 
#line 286 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 286 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 286 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 286 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 286 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[43]; // \n
#line 287 "recordings.ecpp"

}

  reply.out() << _tntChunks[44]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 291 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[45]; // </div></div></div>\n
#line 292 "recordings.ecpp"

    int rec_cnt;
#if VDRVERSNUM >= 20301
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
#else
    rec_cnt = Recordings.Count(); // Access VDRs global cRecordings Recordings instance.
#endif
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[46]; //       
#line 304 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[47]; // \n
#line 305 "recordings.ecpp"

    } else {
      uintptr_t irecoring_item = (uintptr_t)&recoring_item;
      RecordingsItemPtr recItemRoot = recordingsTree->getRoot();
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;

  reply.out() << _tntChunks[48]; //       <form method="post" name="recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 314 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 314 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 314 "recordings.ecpp"
    _tnt_cq7.add( "irecoring_item", (irecoring_item));
#line 314 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[49]; // \n          </ul>\n        </div>\n\t\t\t\t<input type="hidden" name="sort" value="
#line 317 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[50]; // ">\n\t\t\t\t<input type="hidden" name="filter" value="
#line 318 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[51]; // ">\n\t\t\t\t<input type="hidden" name="flat" value="
#line 319 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[52]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 321 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[53]; // </button>\n        </div>\n      </form>\n
#line 324 "recordings.ecpp"

    }

  reply.out() << _tntChunks[54]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[55]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[56]; // \n
  reply.out() << _tntChunks[57]; // \n\n
  reply.out() << _tntChunks[92]; // \n
  reply.out() << _tntChunks[93]; // \n
  reply.out() << _tntChunks[125]; // \n
  reply.out() << _tntChunks[126]; // \n
  reply.out() << _tntChunks[128]; // \n
  reply.out() << _tntChunks[129]; // \n
  reply.out() << _tntChunks[134]; // \n
  reply.out() << _tntChunks[135]; // \n
  reply.out() << _tntChunks[140]; // \n
  reply.out() << _tntChunks[141]; // \n
  reply.out() << _tntChunks[156]; // \n
  reply.out() << _tntChunks[157]; // \n
  reply.out() << _tntChunks[162]; // \n
  reply.out() << _tntChunks[163]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecoring_item = qparam.get< uintptr_t >("irecoring_item", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 340 "recordings.ecpp"

// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
bool reverse = false;
eSortOrder sortOrder = eSortOrder::name; // default
if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = eSortOrder::date;
if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = eSortOrder::errors;
if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = eSortOrder::durationDeviation;
if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = eSortOrder::duplicatesLanguage;
if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
// get rec item of this (current) dir
RecordingsItemPtr recItemThisDir = *(static_cast<RecordingsItemPtr *>((void *)iRecItem) );
int level = recItemThisDir->Level();
cLargeString *recoring_item = static_cast<cLargeString *>((void *)irecoring_item );

std::vector<RecordingsItemPtr> recItems;
const std::vector<RecordingsItemPtr> *recItemsC = NULL;

// data for dirs, an loop over dirs
const std::vector<RecordingsItemPtr> *dirItems = recItemThisDir->getDirs();
std::vector<RecordingsItemPtr>::const_iterator dirIterS, dirIterE, dirIter;
int direction; // for dirs
if (currentFlat != "true") {
  if (currentSort != "duplicates") {
// list of subdirs
    if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") {
// reverse loop over subdirs
      dirIterS = dirItems->end();
      dirIterE = dirItems->begin();
      direction = 0;
    } else {
// forward loop over subdirs
      dirIterS = dirItems->begin();
      dirIterE = dirItems->end();
      direction = 1;
    }
    for (dirIter = dirIterS; dirIter != dirIterE; std::advance(dirIter, direction) ) {
      if(direction == 0) dirIter--;
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>
      RecordingsItemPtr recItem = *dirIter;

      /* search trough directory for new recordings */
      bool newR = false;
      if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
      std::string idHash(xxHash32(parentIdHash + recItem->Name()));
      iRecItem = (uintptr_t)&recItem;
  
  reply.out() << _tntChunks[58]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 391 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[59]; // ')">\n        <table><tr>\n          
#line 393 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[60]; //             <td class = "space">\n              <img src="img/transparent.png" width="
#line 395 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[61]; // px" height="16px" />\n            </td>\n          
#line 397 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[62]; //           <td class="space">\n            <img class="recording_expander" src="
#line 399 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[63]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 401 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[64]; // folder_closed.png" />\n          </td>\n
#line 403 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[65]; //             <td class = space>\n              <div class="thumb">\n                <img data-src="/tvscraper/
#line 406 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[66]; // "\n                  class="
#line 407 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[67]; // "\n                />\n              </div>\n            </td>\n
#line 411 "recordings.ecpp"
         }

  reply.out() << _tntChunks[68]; //         <td class="recording_folder_name
#line 412 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[69]; // ">\n          
#line 413 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[70]; // \n        </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 416 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[71]; // " class="recordingslist" style="display: none;">\n          
  // <& recordings.recordings_item ...
  { 
#line 417 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 417 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 417 "recordings.ecpp"
    _tnt_cq8.add( "irecoring_item", (irecoring_item));
#line 417 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 417 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[72]; // \n        </ul>\n      </li>\n      
#line 420 "recordings.ecpp"

    } // end of loop over subdirs
// now the items
    recItemsC = recItemThisDir->getRecordings(sortOrder);
    if (recItemThisDir->recEntriesSorted() ) reverse = false;
  } // end if (currentSort != "duplicates")
} else {
// here we prepare the items in case of a flat list, no folders
  RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
  if (currentSort != "duplicates") { 
    recItemsC = recordingsTree->allRecordings(sortOrder);
  } else {
    recItems.clear();
    addDuplicateRecordingsSd(recItems, recordingsTree);
    addDuplicateRecordingsLang(recItems, recordingsTree);
    addDuplicateRecordingsNoSd(recItems, recordingsTree);
    recItemsC = &recItems;
  }
}
if (currentSort != "duplicates" || currentFlat == "true") {
  if (recItemsC->empty() ) { 
  reply.out() << _tntChunks[73]; //     <script>\n      rec_ids["fldr_
#line 442 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[74]; // "] = []\n    </script>\n  
#line 444 "recordings.ecpp"
 } else {
    bool first = true;
    const char *displayFolder = currentFlat == "true"?"1":"0";
    recoring_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recoring_item, recItemsC->begin(), recItemsC->end(), first, currentFilter, reverse);
    if (level == 0) { 
  reply.out() << _tntChunks[75]; //       <script>\n        document.write(rec_string_d([
#line 451 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[76]; // , 
#line 451 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[77]; // , [ 
#line 451 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[78]; //  ]]))\n      </script>\n    
#line 453 "recordings.ecpp"
 } else { 
  reply.out() << _tntChunks[79]; //       <script>\n        rec_ids["fldr_
#line 455 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[80]; // "] = [
#line 455 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[81]; // , 
#line 455 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[82]; // , [ 
#line 455 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[83]; //  ]]\n      </script>\n    
#line 457 "recordings.ecpp"
 }
  }
} else {
// duplicates
  RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    if (!recItems.empty() ) {
      std::string idHash(xxHash32(nodeName));
      bool first = true;
      recoring_item->clear();
      RecordingsItemRec::AppendAsJSArray(*recoring_item, recItems.begin(), recItems.end(), first, currentFilter, false);
      
  reply.out() << _tntChunks[84]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 482 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[85]; // ')">\n          <table><tr><td class="space">\n            <img class="recording_expander" src="
#line 484 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[86]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 486 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[87]; // folder_closed.png" />\n          </td><td class="recording_folder_name">\n            
#line 488 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[88]; // \n          </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 491 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[89]; // " class="recordingslist" style="display: none;">\n          <script>\n            rec_ids["fldr_
#line 493 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[90]; // "] = [1, 1, [ 
#line 493 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[91]; //  ]]\n          </script>\n        </ul>\n      </li>\n      
#line 497 "recordings.ecpp"

    }
  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 506 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[94]; // <span class="label bold">
#line 507 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[95]; //  </span>\n<a href="recordings.html\?sort=name&filter=
#line 508 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[96]; // &flat=
#line 508 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[97]; // " 
  // <& setactive ...
  { 
#line 508 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 508 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 508 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[98]; //  >
#line 508 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[99]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 510 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[100]; // &flat=
#line 510 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[101]; // " 
  // <& setactive ...
  { 
#line 510 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 510 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 510 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[102]; //  >
#line 510 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[103]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 512 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[104]; // &flat=
#line 512 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[105]; // " 
  // <& setactive ...
  { 
#line 512 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 512 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 512 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[106]; //  >
#line 512 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[107]; // </a>\n
#line 513 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[108]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=errors&filter=
#line 517 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[109]; // &flat=
#line 517 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[110]; // " 
  // <& setactive ...
  { 
#line 517 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 517 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 517 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[111]; // >
#line 517 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[112]; // </a>\n
#line 518 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[113]; // <span class="sep">|</span>\n<span class="label bold">
#line 523 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[114]; // :&nbsp;<input type="text" name="filter" value="
#line 523 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[115]; // " id="filter" onchange="filterRecordings(this, '
#line 523 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[116]; // ', '
#line 523 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[117]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 523 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 523 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 523 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[118]; // </span>\n
#line 524 "recordings.ecpp"

#endif
if (currentFlat != "true") {

  reply.out() << _tntChunks[119]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 529 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[120]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 529 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 529 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 529 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[121]; // />\n<img onclick="CollapseAll()" src="
#line 530 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[122]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 530 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 530 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 530 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[123]; // />\n
#line 531 "recordings.ecpp"

}

  reply.out() << _tntChunks[124]; // <br />\n
#line 535 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 543 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[127]; // class="active"
#line 544 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 552 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[130]; // <a href="recordings.html\?todel=
#line 552 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[131]; // " 
  // <& tooltip.hint ...
  { 
#line 552 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 552 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 552 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[132]; // ><img src="
#line 552 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[133]; // " alt="" /></a>
#line 552 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 560 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[136]; // <a href="edit_recording.html\?recid=
#line 560 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[137]; // "><img src="
#line 560 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[138]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 560 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 560 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 560 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[139]; //  /></a>
#line 560 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 570 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 571 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 571 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 571 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 571 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 571 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 571 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording")));
#line 571 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n
#line 572 "recordings.ecpp"
   }

  // <& pageelems.m3u_playlist_recording ...
  { 
#line 573 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 573 "recordings.ecpp"
    _tnt_cq19.add( "recid", (id));
#line 573 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[143]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 574 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 574 "recordings.ecpp"
    _tnt_cq20.add( "s_IMDB_ID", (s_IMDB_ID));
#line 574 "recordings.ecpp"
    _tnt_cq20.add( "title", (title));
#line 574 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n
  // <& recordings.edit_rec ...
  { 
#line 575 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 575 "recordings.ecpp"
    _tnt_cq21.add( "id", (id));
#line 575 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[145]; // \n
  // <& recordings.del_rec ...
  { 
#line 576 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 576 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 576 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[146]; // \n
#line 577 "recordings.ecpp"

const cRecording* recording = NULL;
if (!id.empty()) recording = LiveRecordingsManager()->GetByMd5Hash(id);
if (recording && recording->Info() ) {
  int recordingErrors = -1;
#if VDRVERSNUM >= 20505
  recordingErrors = recording->Info()->Errors();
#endif

  cGetScraperVideo getScraperVideo(NULL, recording);
  bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
  if (scraperDataAvailable) {
    int duration_deviation = getScraperVideo.m_scraperVideo->getDurationDeviation();
    int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
    char sdhd = video_SD_HD == 0 ? 's': video_SD_HD == 1 ? 'h': 'u';
    CONVERT(b_recordingErrors, recordingErrors, toCharsI);
    CONVERT(b_duration_deviation, duration_deviation, toCharsI);
    std::string duration;
    if (recording->FileName() )
      AppendDuration(duration, tr("%d:%02d"), recording->LengthInSeconds() );

  reply.out() << _tntChunks[147]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 599 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[148]; // "></span>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 601 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[149]; // ", 
#line 601 "recordings.ecpp"
  reply.sout() << (b_recordingErrors);
  reply.out() << _tntChunks[150]; // , 
#line 601 "recordings.ecpp"
  reply.sout() << (b_duration_deviation);
  reply.out() << _tntChunks[151]; // , "
#line 601 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[152]; // ", "
#line 601 "recordings.ecpp"
  reply.sout() << (recording->Info()->ChannelName()?recording->Info()->ChannelName():"");
  reply.out() << _tntChunks[153]; // ", "
#line 601 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[154]; // ", 
#line 601 "recordings.ecpp"
  reply.sout() << ( GetNumberOfTsFiles(recording) );
  reply.out() << _tntChunks[155]; // )\n</script>\n
#line 603 "recordings.ecpp"

  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[158]; // <img src="
#line 616 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[159]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 616 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 616 "recordings.ecpp"
    _tnt_cq23.add( "text", (archived));
#line 616 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[160]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 617 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 617 "recordings.ecpp"
    _tnt_cq24.add( "s_IMDB_ID", (s_IMDB_ID));
#line 617 "recordings.ecpp"
    _tnt_cq24.add( "title", (title));
#line 617 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[161]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 622 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 622 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[164]; // \n
#line 623 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
