////////////////////////////////////////////////////////////////////////
// searchresults.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.searchresults")

// <%pre>
#line 1 "searchresults.ecpp"


#include <epgsearch.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timers.h>
#include <recman.h>
#include <services.h>


using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class searchresults_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        searchresults_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    searchresults_actions_type searchresults_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("searchresults");

static const char* rawData = "t\000\000\000\341\000\000\000\354\000\000\000\357\000\000\000\364\000\000\000:\001\000"
  "\000=\001\000\000U\001\000\000Y\001\000\000Z\001\000\000\225\001\000\000\305\001\000\000\326\001\000\000\002\002\000"
  "\000%\002\000\000I\002\000\000o\002\000\000q\002\000\000~\002\000\000\266\002\000\000\271\002\000\000\274\002\000\000"
  "\315\002\000\000\017\003\000\000\020\003\000\000\022\003\000\0008\003\000\000:\003\000\000\?\003\000\000\n<html>\n\t<"
  "head>\n\t\t<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>"
  "\n\t\t\n\t\t\n    \n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div c"
  "lass=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t\t<tr cl"
  "ass=\"spacer\">\n\t\t\t\t\t\t\t\t<td colspan=\"\"/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t"
  "\t\t<td colspan=\"\"><div class=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t\t\t</tr>\n<script>\n  docum"
  "ent.write(eventString(, ))\n</script>\n  <script>  \n    document.write(existingRecordingString(, \"\", ))\n  </scrip"
  "t>  \n\t\t\t</table>\n\t\t</div>\n\t</body>\n<script>imgLoad()</script>\n</html>\n\n\n\n\n<a href=\"edit_searchtimer."
  "html\?search=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    searchresults_actions(*this, "searchresults_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchresults " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string searchtimerid = qparam.get< std::string >("searchtimerid");
std::string searchtimerquery = qparam.get< std::string >("searchtimerquery");
std::string searchplain = qparam.get< std::string >("searchplain");
  // </%args>

#line 22 "searchresults.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 25 "searchresults.ecpp"
  typedef std::string searchterm_type;
  TNT_REQUEST_PAGE_VAR(std::string, searchterm, (""));   // <%request> std::string searchterm("")
  _tnt_ignore_unused<searchterm_type>(searchterm);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 28 "searchresults.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = tr("Search results");
	SearchResults results;
	if (!searchtimerid.empty())
		results.GetByID(lexical_cast< int >(searchtimerid));
	if (!searchtimerquery.empty())
		results.GetByQuery(SearchResults::PopQuery(searchtimerquery));
	if (!searchplain.empty())
	{
		SearchTimer s;
		s.SetId(0);
		s.SetSearch(searchplain);
		s.SetSearchMode(0);
		s.SetUseTitle(true);
		s.SetUseSubtitle(false);
		s.SetUseDescription(false);
		results.GetByQuery(s.ToText());

		searchterm = searchplain;
	}

  // <& pageelems.doc_type ...
  { 
#line 51 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 51 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 55 "searchresults.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 56 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 56 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 57 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 57 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 58 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 58 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 61 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 61 "searchresults.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& menu ...
  { 
#line 62 "searchresults.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 62 "searchresults.ecpp"
    _tnt_cq5.add( "active", ("searchepg"));
#line 62 "searchresults.ecpp"
    _tnt_cq5.add( "component", ("searchresults.searchresults_actions"));
#line 62 "searchresults.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t\t<div class="inhalt">\n
#line 64 "searchresults.ecpp"
			if (results.size() == 0) {

  reply.out() << _tntChunks[7]; // \t\t\t\t
#line 65 "searchresults.ecpp"
  reply.sout() << ( tr("No search results") );
  reply.out() << _tntChunks[8]; // \n
#line 66 "searchresults.ecpp"
			}

  reply.out() << _tntChunks[9]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 68 "searchresults.ecpp"

				std::string current_day = "";
				bool display_pictures = !(LiveSetup().GetTvscraperImageDir().empty());
        cLargeString epg_itemS("epg_itemS", 1000);
				RecordingsItemPtr recItem;
				bool recItemFound;

				for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
					epg_itemS.clear();
#if VDRVERSNUM >= 20301
                                       	cStateKey StateKey;
                                      	if (const cChannels *Channels = cChannels::GetChannelsRead(StateKey)) {
#ifdef DEBUG_LOCK
		                		dsyslog("live: pages/searchresults.ecpp LOCK_CHANNELS_READ");
#endif
						cChannel* channel = (cChannel *)Channels->GetByChannelID(result->Channel());
#else
						cChannel* channel = Channels.GetByChannelID(result->Channel());
#endif
						if (!channel) {
         						StateKey.Remove();
							continue;
						}
						const cEvent *event = result->GetEvent(channel);
						std::string day(result->StartTime() ? FormatDateTime(tr("%A, %b %d %Y"), result->StartTime()) : "");
						bool bottom = false;
						SearchResults::iterator nextResult = result; ++nextResult;
						if (nextResult == results.end())
							bottom = true;
						else {
							std::string nextDay(nextResult->StartTime() ? FormatDateTime(tr("%A, %b %d %Y"), nextResult->StartTime()) : "");
							bottom = (day != nextDay);
						}

					        StateKey.Remove();  // release channels read lock before calling event_timer which make a timers read lock
						recItemFound = appendEpgItem(epg_itemS, recItem, event, channel, true);
						int col_span = 4;
						if (display_pictures) col_span++;
						if (current_day != day) {
							if (current_day != "") {


  reply.out() << _tntChunks[10]; // \t\t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t\t<td colspan="
#line 111 "searchresults.ecpp"
  reply.sout() << (col_span);
  reply.out() << _tntChunks[11]; // "/>\n\t\t\t\t\t\t\t</tr>\n
#line 113 "searchresults.ecpp"
							}

  reply.out() << _tntChunks[12]; // \t\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t\t<td colspan="
#line 115 "searchresults.ecpp"
  reply.sout() << (col_span);
  reply.out() << _tntChunks[13]; // "><div class="boxheader"><div><div>
#line 115 "searchresults.ecpp"
  reply.sout() << ( day );
  reply.out() << _tntChunks[14]; // </div></div></div></td>\n\t\t\t\t\t\t</tr>\n
#line 117 "searchresults.ecpp"
							current_day = day;

#line 118 "searchresults.ecpp"
						}

  reply.out() << _tntChunks[15]; // <script>\n  document.write(eventString(
#line 120 "searchresults.ecpp"
  reply.sout() << ((bottom && !recItemFound)?"1":"0");
  reply.out() << _tntChunks[16]; // , 
#line 120 "searchresults.ecpp"
  reply.out() << ( epg_itemS.c_str() );
  reply.out() << _tntChunks[17]; // ))\n</script>\n
#line 122 "searchresults.ecpp"

if(recItemFound) {
  epg_itemS.clear();
  recItem->AppendAsJSArray(epg_itemS, true);

  reply.out() << _tntChunks[18]; //   <script>  \n    document.write(existingRecordingString(
#line 128 "searchresults.ecpp"
  reply.sout() << (col_span - 2);
  reply.out() << _tntChunks[19]; // , "
#line 128 "searchresults.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[20]; // ", 
#line 128 "searchresults.ecpp"
  reply.out() << (epg_itemS.c_str());
  reply.out() << _tntChunks[21]; // ))\n  </script>  \n
#line 130 "searchresults.ecpp"
 } 
#line 131 "searchresults.ecpp"
					}

#line 132 "searchresults.ecpp"
				}

  reply.out() << _tntChunks[22]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n<script>imgLoad()</script>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[23]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[24]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::searchresults_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("searchresults::searchresults_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 25 "searchresults.ecpp"
  typedef std::string searchterm_type;
  TNT_REQUEST_PAGE_VAR(std::string, searchterm, (""));   // <%request> std::string searchterm("")
  _tnt_ignore_unused<searchterm_type>(searchterm);
#line 22 "searchresults.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[25]; // <a href="edit_searchtimer.html\?search=
#line 143 "searchresults.ecpp"
  reply.sout() << ( searchterm );
  reply.out() << _tntChunks[26]; // ">
#line 143 "searchresults.ecpp"
  reply.sout() << ( tr("New search timer") );
  reply.out() << _tntChunks[27]; // </a>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
