////////////////////////////////////////////////////////////////////////
// whats_on.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.whats_on")

// <%pre>
#line 1 "whats_on.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <epgsearch.h>

using namespace vdrlive;

static const size_t maximumTruncDescriptionLength = 150;  // characters for the description in the "boxes"


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class whats_on_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        whats_on_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    whats_on_actions_type whats_on_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("whats_on");

static const char* rawData = "T\001\000\000U\001\000\000V\001\000\000W\001\000\000\302\001\000\000\315\001\000\000\320"
  "\001\000\000\325\001\000\000\225\002\000\000T\003\000\000\313\003\000\000\316\003\000\000\346\003\000\000m\004\000"
  "\000\217\004\000\000\363\004\000\000\365\004\000\000\366\004\000\000Q\005\000\000\232\005\000\000\262\005\000\000\340"
  "\005\000\000\021\006\000\000<\006\000\000m\006\000\000t\006\000\000\233\006\000\000\234\006\000\000\253\006\000\000"
  "\314\006\000\000\330\006\000\000\363\006\000\0007\007\000\000_\007\000\000\234\007\000\000\237\007\000\000\314\007"
  "\000\000\322\007\000\000\323\007\000\000\356\007\000\000\017\010\000\000\033\010\000\000@\010\000\000A\010\000\000z"
  "\010\000\000\273\010\000\000\275\010\000\000\276\010\000\000\334\010\000\000\350\010\000\000\002\t\000\000\003\t\000"
  "\000\004\t\000\000\006\t\000\000\020\t\000\0008\t\000\000G\t\000\000q\t\000\000\232\t\000\000\252\t\000\000\327\t\000"
  "\000\331\t\000\000H\n\000\000Q\n\000\000X\n\000\000[\n\000\000e\n\000\000\227\n\000\000\231\n\000\000\344\n\000\000!"
  "\013\000\000+\013\000\000T\013\000\000V\013\000\000v\013\000\000\242\013\000\000\256\013\000\000\273\013\000\000\275"
  "\013\000\000\302\013\000\000\354\013\000\000\370\013\000\000\005\014\000\000\007\014\000\000\014\014\000\000\n\n\n\n<"
  "html>\n\t<head>\n<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </"
  "title>\n\t\t\n\t\t\n    \n\t\t<script type=\"text/javascript\"><!--\n\t\tfunction showtime(selection)\n\t\t{\n\t\t\ti"
  "f (selection.options[selection.selectedIndex].value != \"\")\n\t\t\t\twindow.location.href = \"whats_on.html\?type=at"
  "&mode=&fixtime=\" + selection.options[selection.selectedIndex].value;\n\t\t}\n\t\tfunction showspectime(selection)\n"
  "\t\t{\n\t\t\tif (selection.value != \"\")\n\t\t\t\twindow.location.href = \"whats_on.html\?type=at&mode=&attime=\" + "
  "selection.value;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\""
  ">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t"
  "\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"9\"><div class=\"boxheader\"><div><div></div></div></div></td>\n\t\t"
  "\t\t</tr>\n\t\t\t<div class=\"event\">\n\t\t\t\t<div class=\"station\">\n\t\t\t\t\t<div><div><div><a href=\"schedule."
  "html\?channel=\" ></a></div></div></div>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"content\">\n\t\t\t\t\t<div class=\"too"
  "ls\">\n\t\t\t\t\t\t\n\t\t\t\t\t</div>\n\t\t\t\t\t<div>\n\t\t\t\t\t\t<div class=\"info nowrap\"><div class=\"date\"></"
  "div><div class=\"time\"></div></div>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t\t<div class="
  "\"title withmargin\"></div>\n\t\t\t\t\t\t<div class=\"short withmargin\"></div>\n\t\t\t\t\t\t<div class=\"description"
  " withmargin\"></div>\n\t\t\t\t\t\t\t<div class=\"more withmargin\"><a > ...</a></div>\n\t\t\t\t\t</div>\n\t\t\t\t</di"
  "v>\n\t\t\t</div>\n\t\t\t<tr>\n\t\t\t\t\n\t\t\t\t<td class=\"topaligned \">\n\t\t\t\t\t<div class=\"withmargin\">\n\t"
  "\t\t\t\t\t<div class=\"nomargin nowrap\"></div>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t</d"
  "iv>\n\t\t\t\t</td>\n\t\t\t\t<td class=\"topaligned \">\n\t\t\t\t\t\t<div class=\"more withmargin\">\n\t\t\t\t\t\t<a\n"
  "\t\t\t\t\t\t\n\t\t\t\t\t\t><span class=\"title\"></span><br /><span class=\"short\"></span></a>\n\t\t\t\t\t\t<div cla"
  "ss=\"withmargin\">\n\t\t\t\t\t\t\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class=\"topaligned rightcol \"><div cl"
  "ass=\"station withmargin\"><a\thref=\"schedule.html\?channel=\" ></a></div>\n\t\t\t\t</td>\n\t\t\t</tr>\n\t\t\t</tabl"
  "e>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n<a class=\"\" href=\"whats_on.html\?type=now&amp;mode=\" id=\"nowhref\"><"
  "/a>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"whats_on.html\?type=next&amp;mode=\" id=\"nexthref\"></a>\n<s"
  "pan class=\"sep\">|</span>\n<span class=\"\"></span>\n<select name=\"userdeftimes\" size=\"1\" id=\"userdeftimes\" on"
  "change=\"showtime(this)\">\n\t<option value=\"0\"/>\n\t<option value=\"\"> </option>\n</select>\n<span class=\"sep\">"
  "|</span>\n<span class=\"\"></span>\n<input type=\"text\" size=\"6\" name=\"spectime\" id=\"spectime\" value = \"\" on"
  "change=\"showspectime(this)\"/>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"whats_on.html\?type=favs&amp;mode"
  "=\"></a>\n<span class=\"sep\">|</span>\n<a href=\"whats_on.html\?mode=detail&amp;type=&amp;attime=&amp;fixtime=\"></a"
  ">\n<a href=\"whats_on.html\?mode=list&amp;type=&amp;attime=&amp;fixtime=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    whats_on_actions(*this, "whats_on_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string type = qparam.get< std::string >("type", ( "now"));
std::string mode = qparam.get< std::string >("mode");
std::string attime = qparam.get< std::string >("attime");
std::string fixtime = qparam.get< std::string >("fixtime");
  // </%args>

#line 21 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 26 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 27 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 28 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 29 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 30 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 34 "whats_on.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");


std::string head;
time_t seektime = 0;
std::string displaytime;
std::string headTime;
std::string headDate;

if (mode.empty())
	mode = LiveSetup().GetLastWhatsOnListMode();
else
	LiveSetup().SetLastWhatsOnListMode(mode);

current_type = type;
current_mode = mode;
current_attime = attime;
current_fixtime = fixtime;

char const * timeFormat = tr("%I:%M %p");
char const * dateFormat = tr("%A, %x");
if (mode == "detail") {
	dateFormat = tr("%a, %x");
}

if (type == "now") {
	headTime = FormatDateTime(timeFormat, time(0));
	headDate = FormatDateTime(dateFormat, time(0));
	head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + " " + headTime;
} else if (type == "next") {
	headTime = FormatDateTime(timeFormat, time(0) + 3600);
	headDate = FormatDateTime(dateFormat, time(0) + 3600);
	head = tr("What's on next?");
} else if (type == "at") {
	if (attime != "")
		displaytime = ExpandTimeString(attime);
	else if (fixtime != "")
		displaytime = ExpandTimeString(fixtime);
	current_displaytime = displaytime;

	seektime = GetTimeT(displaytime);
	if (seektime - time(0) + 3600 < 0) // if wanted time is past more then 1h, then use tomorrow
		seektime += SECSINDAY;
	headTime = FormatDateTime(timeFormat, seektime);
	headDate = FormatDateTime(dateFormat, seektime);
	head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + std::string(" ") + headTime;
} else if (type == "favs") {
	head = tr("Favorites");
}


  // <& pageelems.doc_type ...
  { 
#line 86 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 86 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n\t<head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 90 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[4]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 91 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 91 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 92 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 92 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 93 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 93 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction showtime(selection)\n\t\t{\n\t\t\tif (selection.options[selection.selectedIndex].value != "")\n\t\t\t\twindow.location.href = "whats_on.html\?type=at&mode=
#line 98 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[8]; // &fixtime=" + selection.options[selection.selectedIndex].value;\n\t\t}\n\t\tfunction showspectime(selection)\n\t\t{\n\t\t\tif (selection.value != "")\n\t\t\t\twindow.location.href = "whats_on.html\?type=at&mode=
#line 103 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[9]; // &attime=" + selection.value;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 108 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 108 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n\t\t
  // <& menu ...
  { 
#line 109 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 109 "whats_on.ecpp"
    _tnt_cq5.add( "active", ("whats_on"));
#line 109 "whats_on.ecpp"
    _tnt_cq5.add( "component", ("whats_on.whats_on_actions"));
#line 109 "whats_on.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n\t\t<div class="inhalt">\n
#line 111 "whats_on.ecpp"
			if (mode == "list") {

  reply.out() << _tntChunks[12]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="9"><div class="boxheader"><div><div>
#line 114 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[13]; // </div></div></div></td>\n\t\t\t\t</tr>\n
#line 116 "whats_on.ecpp"
	    }

#line 117 "whats_on.ecpp"

	std::list<EpgInfoPtr> eventList;

	// collect the broadcasts
	if (type != "favs")
	{
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		{
#else
		ReadLock channelsLock( Channels );
		if (channelsLock) {
#endif
#if VDRVERSNUM >= 20301
			for (cChannel *Channel = (cChannel *)Channels->First(); Channel && Channel->Number() <= LiveSetup().GetLastChannel(); Channel = (cChannel *)Channels->Next(Channel)) {
#else
			for (cChannel *Channel = Channels.First(); Channel && Channel->Number() <= LiveSetup().GetLastChannel(); Channel = Channels.Next(Channel)) {
#endif
				if (Channel->GroupSep()) {
					continue;
				}
				const cSchedule *Schedule;
				{
#if VDRVERSNUM >= 20301

					LOCK_SCHEDULES_READ;
#else
					cSchedulesLock schedulesLock;
					const cSchedules* Schedules = cSchedules::Schedules(schedulesLock);
#endif

					Schedule = Schedules->GetSchedule(Channel);
				}
				if (!Schedule) {
					continue;
				}
				const cEvent *Event = NULL;
				if (type == "now")
					Event = Schedule->GetPresentEvent();
				else if (type == "next")
					Event = Schedule->GetFollowingEvent();
				else if (type == "at")
					Event = Schedule->GetEventAround(seektime);

				if (!Event && !LiveSetup().GetShowChannelsWithoutEPG()) continue;

				EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
				eventList.push_back(epgEvent);
			}
		}
	}
	else // get favorite broadcasts from epgsearch
	{
		SearchResults results;
		SearchTimers timers;
		for (SearchTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
			if (!timer->UseInFavorites()) continue;
			SearchResults curresults;
			curresults.GetByID(timer->Id());
			results.merge(curresults);
		}
		time_t now = time(NULL);
		for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
			long diff = result->StartTime() - now;
			if (labs(diff) >= 24*60*60) continue; // skip broadcasts more than a day away
			const cChannel* Channel = result->GetChannel();
			if (!Channel) continue;
			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, result->GetEvent(Channel));
			eventList.push_back(epgEvent);
		}
	}

	// display broadcasts
	for(std::list<EpgInfoPtr>::iterator i = eventList.begin(); i != eventList.end(); ++i ) {
		EpgInfoPtr epgEvent = *i;

		bool truncated = false;
		std::string truncDescription = StringWordTruncate(epgEvent->LongDescr(), maximumTruncDescriptionLength, truncated);
		std::string longDescription = StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars()))
			+ "<br/><br/>" + tr("Click to view details.");
		const cChannel* Channel = epgEvent->Channel();
		if (!Channel) continue;
		int chNumber = Channel->Number();

		std::string startTime(epgEvent->StartTime(tr("%I:%M %p")));
		std::string endTime(epgEvent->EndTime(tr("%I:%M %p")));
		std::string startDate(epgEvent->StartTime(tr("%a, %x")));

		std::string timeSpan(startTime + " - " + endTime);

		if (startTime.empty() && endTime.empty()) {
			timeSpan = mode=="detail" ? headTime : std::string();
			startDate = headDate;
		}
		if (mode == "detail") {

  reply.out() << _tntChunks[14]; // \t\t\t<div class="event">\n\t\t\t\t<div class="station">\n\t\t\t\t\t<div><div><div><a href="schedule.html\?channel=
#line 215 "whats_on.ecpp"
  reply.sout() << ( std::to_string(chNumber) );
  reply.out() << _tntChunks[15]; // " 
  // <& tooltip.hint ...
  { 
#line 215 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 215 "whats_on.ecpp"
    _tnt_cq6.add( "text", (tr("View the schedule of this channel")));
#line 215 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[16]; // >
#line 215 "whats_on.ecpp"
  reply.sout() << ( std::to_string(chNumber) );
#line 215 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
#line 215 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[17]; // </a></div></div></div>\n\t\t\t\t</div>\n\t\t\t\t<div class="content">\n\t\t\t\t\t<div class="tools">\n\t\t\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 219 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 219 "whats_on.ecpp"
    _tnt_cq7.add( "detail", (1));
#line 219 "whats_on.ecpp"
    _tnt_cq7.add( "endTime", (epgEvent->GetEndTime()));
#line 219 "whats_on.ecpp"
    _tnt_cq7.add( "epgid", (epgEvent->Id()));
#line 219 "whats_on.ecpp"
    _tnt_cq7.add( "startTime", (epgEvent->GetStartTime()));
#line 219 "whats_on.ecpp"
    _tnt_cq7.add( "title", (epgEvent->Title()));
#line 219 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n\t\t\t\t\t</div>\n\t\t\t\t\t<div>\n\t\t\t\t\t\t<div class="info nowrap"><div class="date">
#line 222 "whats_on.ecpp"
  reply.sout() << ( (startDate) );
  reply.out() << _tntChunks[19]; // </div><div class="time">
#line 222 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[20]; // </div></div>\n\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 223 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 223 "whats_on.ecpp"
    _tnt_cq8.add( "duration", (epgEvent->Duration()));
#line 223 "whats_on.ecpp"
    _tnt_cq8.add( "progress", (epgEvent->Elapsed()));
#line 223 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[21]; // </div></div>\n\t\t\t\t\t\t<div class="title withmargin">
#line 224 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[22]; // </div>\n\t\t\t\t\t\t<div class="short withmargin">
#line 225 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[23]; // </div>\n\t\t\t\t\t\t<div class="description withmargin">
#line 226 "whats_on.ecpp"
  reply.sout() << ( truncDescription );
  reply.out() << _tntChunks[24]; // </div>\n
#line 227 "whats_on.ecpp"
						if (truncated) {

  reply.out() << _tntChunks[25]; // \t\t\t\t\t\t\t<div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 228 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 228 "whats_on.ecpp"
    _tnt_cq9.add( "text", (longDescription));
#line 228 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 228 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 228 "whats_on.ecpp"
    _tnt_cq10.add( "domId", (epgEvent->Id()));
#line 228 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[26]; // >
#line 228 "whats_on.ecpp"
  reply.sout() << ( 	tr("more") );
  reply.out() << _tntChunks[27]; //  ...</a></div>\n
#line 229 "whats_on.ecpp"
						}

  reply.out() << _tntChunks[28]; // \t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n
#line 233 "whats_on.ecpp"

		} else { // mode == "list"
			std::list<EpgInfoPtr>::iterator last = i;
			bool lastCurrentChanel = (++last == eventList.end());
			tChannelID chanId;
			tEventID eventId;
			EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);

  reply.out() << _tntChunks[29]; // \t\t\t<tr>\n\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 242 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 242 "whats_on.ecpp"
    _tnt_cq11.add( "detail", (0));
#line 242 "whats_on.ecpp"
    _tnt_cq11.add( "endTime", (epgEvent->GetEndTime()));
#line 242 "whats_on.ecpp"
    _tnt_cq11.add( "epgid", (epgEvent->Id()));
#line 242 "whats_on.ecpp"
    _tnt_cq11.add( "lastCurrentChanel", (lastCurrentChanel ? 1 : 0));
#line 242 "whats_on.ecpp"
    _tnt_cq11.add( "startTime", (epgEvent->GetStartTime()));
#line 242 "whats_on.ecpp"
    _tnt_cq11.add( "title", (epgEvent->Title()));
#line 242 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n\t\t\t\t<td class="topaligned 
#line 243 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[31]; // ">\n\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t<div class="nomargin nowrap">
#line 245 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[32]; // </div>\n\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 246 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 246 "whats_on.ecpp"
    _tnt_cq12.add( "duration", (epgEvent->Duration()));
#line 246 "whats_on.ecpp"
    _tnt_cq12.add( "progress", (epgEvent->Elapsed()));
#line 246 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[33]; // </div></div>\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class="topaligned 
#line 249 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[34]; // ">\n
#line 250 "whats_on.ecpp"
					if (eventId != 0) {

  reply.out() << _tntChunks[35]; // \t\t\t\t\t\t<div class="more withmargin">\n\t\t\t\t\t\t<a\n
#line 253 "whats_on.ecpp"
						if (!longDescription.empty()) {

  reply.out() << _tntChunks[36]; // \t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 254 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 254 "whats_on.ecpp"
    _tnt_cq13.add( "text", (longDescription));
#line 254 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 254 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 254 "whats_on.ecpp"
    _tnt_cq14.add( "domId", (epgEvent->Id()));
#line 254 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[37]; // \n
#line 255 "whats_on.ecpp"
						}

  reply.out() << _tntChunks[38]; // \t\t\t\t\t\t><span class="title">
#line 256 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[39]; // </span><br /><span class="short">
#line 256 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[40]; // </span></a>\n
#line 257 "whats_on.ecpp"
					} else {

  reply.out() << _tntChunks[41]; // \t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t
#line 259 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[42]; // \n
#line 260 "whats_on.ecpp"
					}

  reply.out() << _tntChunks[43]; // \t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class="topaligned rightcol 
#line 263 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[44]; // "><div class="station withmargin"><a\thref="schedule.html\?channel=
#line 263 "whats_on.ecpp"
  reply.sout() << ( std::to_string(chNumber) );
  reply.out() << _tntChunks[45]; // " 
  // <& tooltip.hint ...
  { 
#line 263 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 263 "whats_on.ecpp"
    _tnt_cq15.add( "text", (tr("View the schedule of this channel")));
#line 263 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[46]; // >
#line 263 "whats_on.ecpp"
  reply.sout() << ( std::to_string(chNumber) );
#line 263 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
#line 263 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[47]; // </a></div>\n\t\t\t\t</td>\n\t\t\t</tr>\n
#line 266 "whats_on.ecpp"
	}

#line 267 "whats_on.ecpp"

	}

#line 270 "whats_on.ecpp"
	if (mode == "list") {

  reply.out() << _tntChunks[48]; // \t\t\t</table>\n
#line 272 "whats_on.ecpp"
   }

  reply.out() << _tntChunks[49]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[50]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[51]; // \n
  reply.out() << _tntChunks[52]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::whats_on_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on::whats_on_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 21 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 26 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 27 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 28 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 29 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 30 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[53]; // <a class="
#line 281 "whats_on.ecpp"
  if ( current_type == "now" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[54]; // " href="whats_on.html\?type=now&amp;mode=
#line 281 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[55]; // " id="nowhref">
#line 281 "whats_on.ecpp"
  reply.sout() << ( tr("Now") );
  reply.out() << _tntChunks[56]; // </a>\n<span class="sep">|</span>\n<a class="
#line 283 "whats_on.ecpp"
  if ( current_type == "next" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[57]; // " href="whats_on.html\?type=next&amp;mode=
#line 283 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[58]; // " id="nexthref">
#line 283 "whats_on.ecpp"
  reply.sout() << ( tr("Next") );
  reply.out() << _tntChunks[59]; // </a>\n<span class="sep">|</span>\n<span class="
#line 285 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime != "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[60]; // ">
#line 285 "whats_on.ecpp"
  reply.sout() << ( tr("What's on") );
  reply.out() << _tntChunks[61]; // </span>\n<select name="userdeftimes" size="1" id="userdeftimes" onchange="showtime(this)">\n\t<option value="0"/>\n
#line 288 "whats_on.ecpp"

	std::vector< std::string > parts = StringSplit( LiveSetup().GetTimes(), ';' );
	std::vector< std::string >::const_iterator part = parts.begin();
	for ( int i = 0; part != parts.end(); ++i, ++part ) {

  reply.out() << _tntChunks[62]; // \t<option 
#line 293 "whats_on.ecpp"
 reply.out() << ( (current_fixtime != "" && *part == current_displaytime) ? "selected=\"selected\"" : "" ); 
  reply.out() << _tntChunks[63]; // value="
#line 293 "whats_on.ecpp"
  reply.sout() << ( *part );
  reply.out() << _tntChunks[64]; // "> 
#line 293 "whats_on.ecpp"
  reply.sout() << ( tr("at") + std::string(" ") + *part );
  reply.out() << _tntChunks[65]; // </option>\n
#line 294 "whats_on.ecpp"

	}

  reply.out() << _tntChunks[66]; // </select>\n<span class="sep">|</span>\n<span class="
#line 299 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime == "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[67]; // ">
#line 299 "whats_on.ecpp"
  reply.sout() << ( tr("at") );
  reply.out() << _tntChunks[68]; // </span>\n<input type="text" size="6" name="spectime" id="spectime" value = "
#line 300 "whats_on.ecpp"
  if ( current_attime != "" )
    reply.sout() <<  current_displaytime ;
  reply.out() << _tntChunks[69]; // " onchange="showspectime(this)"/>\n<span class="sep">|</span>\n
#line 302 "whats_on.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[70]; // <a class="
#line 303 "whats_on.ecpp"
  if ( current_type == "favs" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[71]; // " href="whats_on.html\?type=favs&amp;mode=
#line 303 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[72]; // ">
#line 303 "whats_on.ecpp"
  reply.sout() << ( tr("Favorites") );
  reply.out() << _tntChunks[73]; // </a>\n<span class="sep">|</span>\n
#line 305 "whats_on.ecpp"
 }

#line 306 "whats_on.ecpp"
 if ( current_mode == "list" ) {

  reply.out() << _tntChunks[74]; // <a href="whats_on.html\?mode=detail&amp;type=
#line 307 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[75]; // &amp;attime=
#line 307 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[76]; // &amp;fixtime=
#line 307 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[77]; // ">
#line 307 "whats_on.ecpp"
  reply.sout() << ( tr("Details view") );
  reply.out() << _tntChunks[78]; // </a>\n
#line 308 "whats_on.ecpp"
 } else {

  reply.out() << _tntChunks[79]; // <a href="whats_on.html\?mode=list&amp;type=
#line 309 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[80]; // &amp;attime=
#line 309 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[81]; // &amp;fixtime=
#line 309 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[82]; // ">
#line 309 "whats_on.ecpp"
  reply.sout() << ( tr("List view") );
  reply.out() << _tntChunks[83]; // </a>\n
#line 310 "whats_on.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
